<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN"
"http://www.w3.org/TR/html4/strict.dtd">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html;charset=utf-8">
<link rel="stylesheet" href="style.css" type="text/css">
<title>memorymodel.html</title>
</head>
<body>
<div class="why3doc">
<pre><span class="keyword">module</span> <a name="VAL_TYPES_">VAL_TYPES</a>

  <span class="keyword">use</span> set.Fset
  <span class="keyword">use</span> int.<a href="int.html#Int_">Int</a>

  <span class="keyword">type</span> <a name="value_6">value</a> 'a = <a href="set.html#fset_238">fset</a> 'a
  <span class="keyword">val</span> <span class="keyword">function</span> <a name="vundef_7">vundef</a> 'a : <a href="#value_6">value</a> 'a

  <span class="keyword">function</span> <a name="compat_9">compat</a> (memtype1: <a href="set.html#fset_238">fset</a> 'a) (memtype2: <a href="set.html#fset_238">fset</a> 'a) : bool
  <span class="keyword">function</span> <a name="sizeof_10">sizeof</a> (memtype: <a href="set.html#fset_238">fset</a> 'a) : int
  <span class="keyword">function</span> <a name="alignof_11">alignof</a> (memtype: <a href="set.html#fset_238">fset</a> 'a) : int
  <span class="keyword">function</span> <a name="convert_12">convert</a> (memtype: <a href="set.html#fset_238">fset</a> 'a) (v: <a href="#value_6">value</a> 'a) : <a href="#value_6">value</a> 'a

  <span class="keyword">axiom</span> <a name="sizeof_pos_14">sizeof_pos</a>:
    <span class="keyword">forall</span> ty: <a href="set.html#fset_238">fset</a> 'a. <a href="#sizeof_10">sizeof</a> ty <a href="int.html#infix%20%3E_24">&gt;</a> 0

  <span class="keyword">axiom</span> <a name="compat_sizeof_17">compat_sizeof</a>:
    <span class="keyword">forall</span> ty ty': <a href="set.html#fset_238">fset</a> 'a. <a href="#compat_9">compat</a> ty ty' -&gt; <a href="#sizeof_10">sizeof</a> ty' = <a href="#sizeof_10">sizeof</a> ty

  <span class="keyword">axiom</span> <a name="alignof_pos_21">alignof_pos</a>:
    <span class="keyword">forall</span> ty: <a href="set.html#fset_238">fset</a> 'a. <a href="#alignof_11">alignof</a> ty <a href="int.html#infix%20%3E_24">&gt;</a> 0

  <span class="keyword">val</span> <span class="keyword">function</span> <a name="max_alignment_24">max_alignment</a> : int

  <span class="keyword">predicate</span> <a name="divide_26">divide</a> (x: int) (y: int)
  = <span class="keyword">exists</span> z. y = z<a href="int.html#infix%20*_20">*</a>x

  <span class="keyword">axiom</span> <a name="alignof_div_29">alignof_div</a>: <span class="keyword">forall</span> ty: <a href="set.html#fset_238">fset</a> 'a.
    (<a href="#divide_26">divide</a> (<a href="#alignof_11">alignof</a> ty) <a href="#max_alignment_24">max_alignment</a>)

  <span class="keyword">axiom</span> <a name="compat_alignof_32">compat_alignof</a>:
    <span class="keyword">forall</span> ty ty':<a href="set.html#fset_238">fset</a> 'a. <a href="#compat_9">compat</a> ty ty' -&gt; <a href="#alignof_11">alignof</a> ty' = <a href="#alignof_11">alignof</a> ty

<span class="keyword">end</span>

<span class="keyword">module</span> <a name="GEM_MEM_">GEM_MEM</a>

  <span class="keyword">use</span> <span class="keyword">export</span> set.<a href="set.html#Fset_">Fset</a>
  <span class="keyword">use</span> <span class="keyword">export</span> int.<a href="int.html#Int_">Int</a>
  <span class="keyword">use</span> <span class="keyword">export</span> option.<a href="option.html#Option_">Option</a>
  <span class="keyword">use</span> <span class="keyword">export</span> <a href="#VAL_TYPES_">VAL_TYPES</a>

  <span class="keyword">type</span> <a name="mem_44">mem</a> 'a = <a href="set.html#fset_238">fset</a> 'a
  <span class="keyword">type</span> <a name="block_45">block</a> 'a = <a href="set.html#fset_238">fset</a> 'a

  <span class="keyword">function</span> <a name="alloc_47">alloc</a> (m: <a href="#mem_44">mem</a> 'a) (l: int) (h: int) : <a href="option.html#option_5">option</a> (<a href="#block_45">block</a> 'a, <a href="#mem_44">mem</a> 'a)
  <span class="keyword">function</span> <a name="load_48">load</a> (memtype: <a href="set.html#fset_238">fset</a> 'a) (m: <a href="#mem_44">mem</a> 'a) (b: <a href="#block_45">block</a> 'a) (i: int) : <a href="option.html#option_5">option</a> (<a href="set.html#fset_238">fset</a> 'a)
  <span class="keyword">function</span> <a name="store_49">store</a> (memtype: <a href="set.html#fset_238">fset</a> 'a) (m: <a href="#mem_44">mem</a> 'a) (b: <a href="#block_45">block</a> 'a) (i: int) (v: <a href="set.html#fset_238">fset</a> 'a) : <a href="option.html#option_5">option</a> (<a href="#mem_44">mem</a> 'a)
  <span class="keyword">function</span> <a name="free_50">free</a> (m: <a href="#mem_44">mem</a> 'a) (b: <a href="#block_45">block</a> 'a) : <a href="option.html#option_5">option</a> (<a href="#mem_44">mem</a> 'a)

  <span class="keyword">axiom</span> <a name="load_alloc_other_52">load_alloc_other</a>:
    <span class="keyword">forall</span> m: <a href="set.html#fset_238">fset</a> 'a, lo hi b m' ty b' ofs.
      <a href="#alloc_47">alloc</a> m lo hi = <a href="option.html#Some_5">Some</a> (b,m') -&gt;
      b' &lt;&gt; b -&gt;
      <a href="#load_48">load</a> ty m' b' ofs = <a href="#load_48">load</a> ty m b' ofs

  <span class="keyword">axiom</span> <a name="load_store_same_58">load_store_same</a>:
    <span class="keyword">forall</span> ty, m: <a href="set.html#fset_238">fset</a> 'a, b ofs v m' ty'.
      <a href="#store_49">store</a> ty m b ofs v = <a href="option.html#Some_5">Some</a> m' -&gt;
      <a href="#compat_9">compat</a> ty ty' -&gt;
      <a href="#load_48">load</a> ty' m' b ofs = <a href="option.html#Some_5">Some</a> (<a href="#convert_12">convert</a> ty' v)

  <span class="keyword">axiom</span> <a name="load_store_disjoin_65">load_store_disjoin</a>:
    <span class="keyword">forall</span> ty m b ofs v, m':<a href="set.html#fset_238">fset</a> 'a ,ty' b' ofs'.
      <a href="#store_49">store</a> ty m b ofs v = <a href="option.html#Some_5">Some</a> m' -&gt;
      b' &lt;&gt; b \/ ofs' <a href="int.html#infix%20+_19">+</a> <a href="#sizeof_10">sizeof</a> ty' <a href="int.html#infix%20%3C=_25">&lt;=</a> ofs \/ ofs <a href="int.html#infix%20+_19">+</a> <a href="#sizeof_10">sizeof</a> ty <a href="int.html#infix%20%3C=_25">&lt;=</a> ofs' -&gt;
      <a href="#load_48">load</a> ty' m' b' ofs' = <a href="#load_48">load</a> ty' m b' ofs'

  <span class="keyword">axiom</span> <a name="load_free_other_71">load_free_other</a>:
    <span class="keyword">forall</span> m:<a href="set.html#fset_238">fset</a> 'a, b m' ty b' ofs.
      <a href="#free_50">free</a> m b = <a href="option.html#Some_5">Some</a> m' -&gt;
      b' &lt;&gt; b -&gt;
      <a href="#load_48">load</a> ty m' b' ofs = <a href="#load_48">load</a> ty m b' ofs

  <span class="keyword">function</span> <a name="valid_block_78">valid_block</a> (mem: <a href="#mem_44">mem</a> 'a) (b: <a href="#block_45">block</a> 'a) : bool

  <span class="keyword">axiom</span> <a name="alloc_balid_block_80">alloc_balid_block</a>:
    <span class="keyword">forall</span> m:<a href="set.html#fset_238">fset</a> 'a, lo hi b m' b'.
      <a href="#alloc_47">alloc</a> m lo hi = <a href="option.html#Some_5">Some</a> (b, m') -&gt;
      (<a href="#valid_block_78">valid_block</a> m' b' &lt;-&gt; b' = b \/ <a href="#valid_block_78">valid_block</a> m b')

  <span class="keyword">axiom</span> <a name="alloc_not_valid_block_85">alloc_not_valid_block</a>:
    <span class="keyword">forall</span> m: <a href="set.html#fset_238">fset</a> 'a, lo hi b m'.
      <a href="#alloc_47">alloc</a> m lo hi = <a href="option.html#Some_5">Some</a> (b, m') -&gt;
        <span class="keyword">not</span> <a href="#valid_block_78">valid_block</a> m b

  <span class="keyword">axiom</span> <a name="load_valid_block_90">load_valid_block</a>:
    <span class="keyword">forall</span> ty, m: <a href="set.html#fset_238">fset</a> 'a, b ofs v.
      <a href="#load_48">load</a> ty m b ofs = <a href="option.html#Some_5">Some</a> v -&gt;
      <a href="#valid_block_78">valid_block</a> m b

  <span class="keyword">axiom</span> <a name="store_valid_block_95">store_valid_block</a>:
    <span class="keyword">forall</span> ty, m: <a href="set.html#fset_238">fset</a> 'a, b ofs v m'.
      <a href="#store_49">store</a> ty m b ofs v = <a href="option.html#Some_5">Some</a> m' -&gt;
      <a href="#valid_block_78">valid_block</a> m b

  <span class="keyword">axiom</span> <a name="store_valid_block_inv_100">store_valid_block_inv</a>:
    <span class="keyword">forall</span> ty, m: <a href="set.html#fset_238">fset</a> 'a, b ofs v m' b'.
      <a href="#store_49">store</a> ty m b ofs v = <a href="option.html#Some_5">Some</a> m' -&gt;
      (<a href="#valid_block_78">valid_block</a> m' b' &lt;-&gt; <a href="#valid_block_78">valid_block</a> m b')

  <span class="keyword">axiom</span> <a name="free_valid_block_105">free_valid_block</a>:
    <span class="keyword">forall</span> m: <a href="set.html#fset_238">fset</a> 'a, b m' b'.
      <a href="#free_50">free</a> m b = <a href="option.html#Some_5">Some</a> m' -&gt;
      b' &lt;&gt; b -&gt;
      (<a href="#valid_block_78">valid_block</a> m' b' &lt;-&gt; <a href="#valid_block_78">valid_block</a> m b')

  <span class="keyword">axiom</span> <a name="valid_block_free_111">valid_block_free</a>:
    <span class="keyword">forall</span> m: <a href="set.html#fset_238">fset</a> 'a, b.
      <a href="#valid_block_78">valid_block</a> m b -&gt;
      <span class="keyword">exists</span> m'. <a href="#free_50">free</a> m b = <a href="option.html#Some_5">Some</a> m'

  <span class="keyword">function</span> <a name="bounds_117">bounds</a> (m: <a href="#mem_44">mem</a> 'a) (b: <a href="#block_45">block</a> 'a) : (int, int)

  <span class="keyword">axiom</span> <a name="alloc_result_bounds_119">alloc_result_bounds</a>:
    <span class="keyword">forall</span> m: <a href="set.html#fset_238">fset</a> 'a, lo hi b m'.
      <a href="#alloc_47">alloc</a> m lo hi = <a href="option.html#Some_5">Some</a>(b, m') -&gt;
      <a href="#bounds_117">bounds</a> m' b = (lo, hi)

  <span class="keyword">axiom</span> <a name="alloc_bounds_inv_124">alloc_bounds_inv</a>:
    <span class="keyword">forall</span> m: <a href="set.html#fset_238">fset</a> 'a, lo hi b m' b'.
      <a href="#alloc_47">alloc</a> m lo hi = <a href="option.html#Some_5">Some</a>(b, m') -&gt;
      b' &lt;&gt; b -&gt;
      <a href="#bounds_117">bounds</a> m' b' = <a href="#bounds_117">bounds</a> m b'

  <span class="keyword">axiom</span> <a name="store_bounds_inv_130">store_bounds_inv</a>:
    <span class="keyword">forall</span> ty, m: <a href="set.html#fset_238">fset</a> 'a, b ofs v m' b'.
      <a href="#store_49">store</a> ty m b ofs v = <a href="option.html#Some_5">Some</a> m' -&gt;
      <a href="#bounds_117">bounds</a> m' b' = <a href="#bounds_117">bounds</a> m b'

  <span class="keyword">axiom</span> <a name="free_bounds_inv_135">free_bounds_inv</a>:
    <span class="keyword">forall</span> m: <a href="set.html#fset_238">fset</a> 'a, b m' b'.
      <a href="#free_50">free</a> m b = <a href="option.html#Some_5">Some</a> m' -&gt;
      b' &lt;&gt; b -&gt;
      <a href="#bounds_117">bounds</a> m' b' = <a href="#bounds_117">bounds</a> m b'

  <span class="keyword">function</span> <a name="fst_141">fst</a> (p: ('a,'b)) : 'a
  = <span class="keyword">let</span> x, _ = p <span class="keyword">in</span> x

  <span class="keyword">function</span> <a name="snd_145">snd</a> (p: ('a,'b)) : 'b
  = <span class="keyword">let</span> _, y = p <span class="keyword">in</span> y

  <span class="keyword">predicate</span> <a name="valid_pointer_148">valid_pointer</a> (ty: <a href="set.html#fset_238">fset</a> 'a) (m: <a href="#mem_44">mem</a> 'a) (b: <a href="#block_45">block</a> 'a) (ofs: int) =
    <a href="#valid_block_78">valid_block</a> m b /\ <a href="#fst_141">fst</a> (<a href="#bounds_117">bounds</a> m b) <a href="int.html#infix%20%3C=_25">&lt;=</a> ofs /\
    (<a href="#divide_26">divide</a> (<a href="#alignof_11">alignof</a> ty) ofs) /\
    ofs <a href="int.html#infix%20+_19">+</a> (<a href="#sizeof_10">sizeof</a> ty) <a href="int.html#infix%20%3C=_25">&lt;=</a> <a href="#snd_145">snd</a> (<a href="#bounds_117">bounds</a> m b)

  <span class="keyword">axiom</span> <a name="valid_pointer_store_154">valid_pointer_store</a>:
    <span class="keyword">forall</span> ty, m: <a href="set.html#fset_238">fset</a> 'a, b ofs v.
      <a href="#valid_pointer_148">valid_pointer</a> ty m b ofs -&gt;
      <span class="keyword">exists</span> m'. <a href="#store_49">store</a> ty m b ofs v = <a href="option.html#Some_5">Some</a> m'

<span class="keyword">end</span>

<span class="keyword">module</span> <a name="Gen_Mem_Facts_">Gen_Mem_Facts</a>

  <span class="keyword">use</span> <span class="keyword">export</span> <a href="#GEM_MEM_">GEM_MEM</a>

  <span class="keyword">lemma</span> <a name="alloc_valid_block_inv_168">alloc_valid_block_inv</a>:
    <span class="keyword">forall</span> m:<a href="set.html#fset_238">fset</a> 'a, lo hi b m' b'.
      <a href="#alloc_47">alloc</a> m lo hi = <a href="option.html#Some_5">Some</a>(b, m') -&gt; <a href="#valid_block_78">valid_block</a> m b' -&gt; <a href="#valid_block_78">valid_block</a> m' b'

  <span class="keyword">lemma</span> <a name="alloc_not_valid_block_2_172">alloc_not_valid_block_2</a>:
    <span class="keyword">forall</span> m:<a href="set.html#fset_238">fset</a> 'a, lo hi b m' b'.
      <a href="#alloc_47">alloc</a> m lo hi = <a href="option.html#Some_5">Some</a>(b, m') -&gt;
      <a href="#valid_block_78">valid_block</a> m b' -&gt; b' &lt;&gt; b

  <span class="keyword">lemma</span> <a name="load_alloc_other_2_178">load_alloc_other_2</a>:
    <span class="keyword">forall</span> m:<a href="set.html#fset_238">fset</a> 'a, lo hi b m' b' ty ofs v.
      <a href="#alloc_47">alloc</a> m lo hi = <a href="option.html#Some_5">Some</a>(b, m') -&gt;
      <a href="#load_48">load</a> ty m b' ofs = <a href="option.html#Some_5">Some</a> v -&gt;
      <a href="#load_48">load</a> ty m' b' ofs = <a href="option.html#Some_5">Some</a> v

  <span class="keyword">lemma</span> <a name="alloc_result_valid_pointer_185">alloc_result_valid_pointer</a>:
    <span class="keyword">forall</span> m:<a href="set.html#fset_238">fset</a> 'a, lo hi b m' ty ofs.
      <a href="#alloc_47">alloc</a> m lo hi = <a href="option.html#Some_5">Some</a>(b, m') -&gt;
      (<a href="#divide_26">divide</a> (<a href="#alignof_11">alignof</a> ty) ofs) -&gt; lo <a href="int.html#infix%20%3C=_25">&lt;=</a> ofs -&gt; ofs <a href="int.html#infix%20+_19">+</a> <a href="#sizeof_10">sizeof</a> ty <a href="int.html#infix%20%3C=_25">&lt;=</a> hi -&gt;
      <a href="#valid_pointer_148">valid_pointer</a> ty m' b ofs

  <span class="keyword">lemma</span> <a name="alloc_valid_pointer_inv_192">alloc_valid_pointer_inv</a>:
    <span class="keyword">forall</span> m:<a href="set.html#fset_238">fset</a> 'a, lo hi b m' ty b' ofs.
      <a href="#alloc_47">alloc</a> m lo hi = <a href="option.html#Some_5">Some</a>(b, m') -&gt;
      <a href="#valid_pointer_148">valid_pointer</a> ty m b' ofs -&gt; <a href="#valid_pointer_148">valid_pointer</a> ty m' b' ofs

  <span class="keyword">lemma</span> <a name="store_valid_pointer_inv_198">store_valid_pointer_inv</a>:
    <span class="keyword">forall</span> ty, m:<a href="set.html#fset_238">fset</a> 'a, b ofs v m' ty' b' ofs'.
      <a href="#store_49">store</a> ty m b ofs v = <a href="option.html#Some_5">Some</a> m' -&gt;
      (<a href="#valid_pointer_148">valid_pointer</a> ty' m' b' ofs' &lt;-&gt; <a href="#valid_pointer_148">valid_pointer</a> ty' m b' ofs')

  <span class="keyword">lemma</span> <a name="free_valid_pointer_inv_203">free_valid_pointer_inv</a>:
    <span class="keyword">forall</span> m:<a href="set.html#fset_238">fset</a> 'a, b m' ty b' ofs.
      <a href="#free_50">free</a> m b = <a href="option.html#Some_5">Some</a> m' -&gt; b' &lt;&gt; b -&gt;
      (<a href="#valid_pointer_148">valid_pointer</a> ty m' b' ofs &lt;-&gt; <a href="#valid_pointer_148">valid_pointer</a> ty m b' ofs)

  <span class="keyword">function</span> <a name="proj_pointer_209">proj_pointer</a> (v: <a href="#value_6">value</a> 'a) : <a href="option.html#option_5">option</a> (<a href="#block_45">block</a> 'a, int)

  <span class="keyword">function</span> <a name="loadv_211">loadv</a> (ty: <a href="set.html#fset_238">fset</a> 'a) (m: <a href="#mem_44">mem</a> 'a) (v: <a href="#value_6">value</a> 'a) : <a href="option.html#option_5">option</a> (<a href="#value_6">value</a> 'a)
  = <span class="keyword">match</span> <a href="#proj_pointer_209">proj_pointer</a> v <span class="keyword">with</span>
    | <a href="option.html#Some_5">Some</a>(b, ofs) -&gt; <a href="#load_48">load</a> ty m b ofs
    | <a href="option.html#None_5">None</a> -&gt; <a href="option.html#None_5">None</a>
    <span class="keyword">end</span>

  <span class="keyword">function</span> <a name="storev_217">storev</a> (ty: <a href="set.html#fset_238">fset</a> 'a) (m: <a href="#mem_44">mem</a> 'a) (addr v: <a href="#value_6">value</a> 'a) : <a href="option.html#option_5">option</a> (<a href="#mem_44">mem</a> 'a)
  = <span class="keyword">match</span> <a href="#proj_pointer_209">proj_pointer</a> addr <span class="keyword">with</span>
    | <a href="option.html#Some_5">Some</a>(b, ofs) -&gt; <a href="#store_49">store</a> ty m b ofs v
    | <a href="option.html#None_5">None</a> -&gt; <a href="option.html#None_5">None</a>
    <span class="keyword">end</span>

<span class="keyword">end</span>

<span class="keyword">module</span> <a name="REF_GEN_MEM_">REF_GEN_MEM</a>

  <span class="keyword">use</span> <span class="keyword">export</span> <a href="#Gen_Mem_Facts_">Gen_Mem_Facts</a>

  <span class="keyword">axiom</span> <a name="valid_pointer_load_229">valid_pointer_load</a>:
    <span class="keyword">forall</span> ty, m: <a href="#mem_44">mem</a> 'a, b ofs.
      <a href="#valid_pointer_148">valid_pointer</a> ty m b ofs -&gt;
      <span class="keyword">exists</span> v. <a href="#load_48">load</a> ty m b ofs = <a href="option.html#Some_5">Some</a> v

  <span class="keyword">axiom</span> <a name="store_valid_pointer_234">store_valid_pointer</a>:
    <span class="keyword">forall</span> ty, m: <a href="#mem_44">mem</a> 'a, b ofs v m'.
      <a href="#store_49">store</a> ty m b ofs v = <a href="option.html#Some_5">Some</a> m' -&gt;
      <a href="#valid_pointer_148">valid_pointer</a> ty m b ofs

  <span class="keyword">axiom</span> <a name="load_valid_pointer_239">load_valid_pointer</a>:
    <span class="keyword">forall</span> ty, m: <a href="#mem_44">mem</a> 'a, b ofs v.
      <a href="#load_48">load</a> ty m b ofs = <a href="option.html#Some_5">Some</a> v -&gt;
      <a href="#valid_pointer_148">valid_pointer</a> ty m b ofs

  <span class="keyword">axiom</span> <a name="load_alloc_same_244">load_alloc_same</a>:
    <span class="keyword">forall</span> m: <a href="#mem_44">mem</a> 'a, lo hi b m' ty ofs, v: <a href="#value_6">value</a> 'a.
      <a href="#alloc_47">alloc</a> m lo hi = <a href="option.html#Some_5">Some</a> (b, m') -&gt;
      <a href="#load_48">load</a> ty m' b ofs = <a href="option.html#Some_5">Some</a> v -&gt;
      <span class="keyword">exists</span> a. v = (<a href="#vundef_7">vundef</a> a)

  <span class="keyword">axiom</span> <a name="load_store_mismatch_250">load_store_mismatch</a>:
    <span class="keyword">forall</span> ty, m: <a href="#mem_44">mem</a> 'a, b ofs v m' ty' v'.
      <a href="#store_49">store</a> ty m b ofs v = <a href="option.html#Some_5">Some</a> m' -&gt;
      <span class="keyword">not</span> <a href="#compat_9">compat</a> ty ty' -&gt;
      <a href="#load_48">load</a> ty' m' b ofs = <a href="option.html#Some_5">Some</a> v' -&gt;
      <span class="keyword">exists</span> a. v' = (<a href="#vundef_7">vundef</a> a)

  <span class="keyword">axiom</span> <a name="load_store_overlap_258">load_store_overlap</a>:
    <span class="keyword">forall</span> ty, m: <a href="#mem_44">mem</a> 'a, b ofs v m' ty' ofs' v'.
      <a href="#store_49">store</a> ty m b ofs v = <a href="option.html#Some_5">Some</a> m' -&gt;
      ofs' &lt;&gt; ofs -&gt; ofs' <a href="int.html#infix%20+_19">+</a> <a href="#sizeof_10">sizeof</a> ty' <a href="int.html#infix%20%3E_24">&gt;</a> ofs -&gt; ofs <a href="int.html#infix%20+_19">+</a> <a href="#sizeof_10">sizeof</a> ty <a href="int.html#infix%20%3E_24">&gt;</a> ofs' -&gt;
      <a href="#load_48">load</a> ty' m' b ofs' = <a href="option.html#Some_5">Some</a> v' -&gt;
      <span class="keyword">exists</span> a. v' = (<a href="#vundef_7">vundef</a> a)

  <span class="keyword">function</span> <a name="fresh_block_265">fresh_block</a> (m: <a href="#mem_44">mem</a> 'a) (b: <a href="#block_45">block</a> 'a) : bool

  <span class="keyword">axiom</span> <a name="fresh_valid_block_exclusive_267">fresh_valid_block_exclusive</a>:
    <span class="keyword">forall</span> m: <a href="#mem_44">mem</a> 'a, b.
      <a href="#fresh_block_265">fresh_block</a> m b -&gt; <a href="#valid_block_78">valid_block</a> m b -&gt; False

  <span class="keyword">axiom</span> <a name="alloc_fresh_block_271">alloc_fresh_block</a>:
    <span class="keyword">forall</span> m: <a href="#mem_44">mem</a> 'a, lo hi b m' b'.
      <a href="#alloc_47">alloc</a> m lo hi = <a href="option.html#Some_5">Some</a>(b, m') -&gt;
      (<a href="#fresh_block_265">fresh_block</a> m' b' &lt;-&gt; b &lt;&gt; b' /\ <a href="#fresh_block_265">fresh_block</a> m b')

  <span class="keyword">axiom</span> <a name="alloc_fresh_block_2_276">alloc_fresh_block_2</a>:
    <span class="keyword">forall</span> m: <a href="#mem_44">mem</a> 'a, lo hi b m'.
      <a href="#alloc_47">alloc</a> m lo hi = <a href="option.html#Some_5">Some</a>(b, m') -&gt; <a href="#fresh_block_265">fresh_block</a> m b

  <span class="keyword">axiom</span> <a name="store_fresh_block_280">store_fresh_block</a>:
    <span class="keyword">forall</span> m: <a href="#mem_44">mem</a> 'a, chunk b ofs v m' b'.
      <a href="#store_49">store</a> chunk m b ofs v = <a href="option.html#Some_5">Some</a> m' -&gt;
      (<a href="#fresh_block_265">fresh_block</a> m' b' &lt;-&gt; <a href="#fresh_block_265">fresh_block</a> m b')

  <span class="keyword">axiom</span> <a name="free_fresh_block_285">free_fresh_block</a>:
    <span class="keyword">forall</span> m: <a href="#mem_44">mem</a> 'a, b m' b'.
      <a href="#free_50">free</a> m b = <a href="option.html#Some_5">Some</a> m' -&gt;
      (<a href="#fresh_block_265">fresh_block</a> m' b' &lt;-&gt; <a href="#fresh_block_265">fresh_block</a> m b')

  <span class="keyword">predicate</span> <a name="same_domain_290">same_domain</a> (m1 m2: <a href="#mem_44">mem</a> 'a)
  = <span class="keyword">forall</span> b. <a href="#fresh_block_265">fresh_block</a> m1 b &lt;-&gt; <a href="#fresh_block_265">fresh_block</a> m2 b

  <span class="keyword">axiom</span> <a name="alloc_same_domain_294">alloc_same_domain</a>:
    <span class="keyword">forall</span> m1: <a href="#mem_44">mem</a> 'a, lo1 hi1 b1 m1' m2 lo2 hi2 b2 m2'.
      <a href="#alloc_47">alloc</a> m1 lo1 hi1 = <a href="option.html#Some_5">Some</a>(b1, m1') -&gt;
      <a href="#alloc_47">alloc</a> m2 lo2 hi2 = <a href="option.html#Some_5">Some</a>(b2, m2') -&gt;
      <a href="#same_domain_290">same_domain</a> m1 m2 -&gt;
      b1 = b2 /\ <a href="#same_domain_290">same_domain</a> m1' m2'

  <span class="keyword">axiom</span> <a name="free_not_valid_block_301">free_not_valid_block</a>:
    <span class="keyword">forall</span> m: <a href="#mem_44">mem</a> 'a, b m'.
      <a href="#free_50">free</a> m b = <a href="option.html#Some_5">Some</a> m' -&gt; <span class="keyword">not</span> (<a href="#valid_block_78">valid_block</a> m' b)

  <span class="keyword">axiom</span> <a name="free_same_bounds_305">free_same_bounds</a>:
    <span class="keyword">forall</span> m: <a href="#mem_44">mem</a> 'a, b m'.
      <a href="#free_50">free</a> m b = <a href="option.html#Some_5">Some</a> m' -&gt;
      <a href="#fst_141">fst</a>(<a href="#bounds_117">bounds</a> m' b) = <a href="#snd_145">snd</a>(<a href="#bounds_117">bounds</a> m' b)

<span class="keyword">end</span>

<span class="keyword">module</span> <a name="Ref_Gen_Mem_Facts_">Ref_Gen_Mem_Facts</a>

  <span class="keyword">use</span> <span class="keyword">export</span> <a href="#REF_GEN_MEM_">REF_GEN_MEM</a>

  <span class="keyword">lemma</span> <a name="store_valid_pointer_2_316">store_valid_pointer_2</a>:
    <span class="keyword">forall</span> ty, m: <a href="#mem_44">mem</a> 'a, b ofs v m'.
      <a href="#store_49">store</a> ty m b ofs v = <a href="option.html#Some_5">Some</a> m' -&gt; <a href="#valid_pointer_148">valid_pointer</a> ty m' b ofs

  <span class="keyword">lemma</span> <a name="load_alloc_same_2_320">load_alloc_same_2</a>:
    <span class="keyword">forall</span> m: <a href="#mem_44">mem</a> 'a, lo hi b m' ty ofs.
      <a href="#alloc_47">alloc</a> m lo hi = <a href="option.html#Some_5">Some</a> (b, m') -&gt;
      (<a href="#divide_26">divide</a> (<a href="#alignof_11">alignof</a> ty) ofs) -&gt; lo <a href="int.html#infix%20%3C=_25">&lt;=</a> ofs -&gt; ofs <a href="int.html#infix%20+_19">+</a> <a href="#sizeof_10">sizeof</a> ty <a href="int.html#infix%20%3C=_25">&lt;=</a> hi -&gt;
      <span class="keyword">exists</span> a. <a href="#load_48">load</a> ty m' b ofs = <a href="option.html#Some_5">Some</a> (<a href="#vundef_7">vundef</a> a)

  <span class="keyword">lemma</span> <a name="load_store_mismatch_2_326">load_store_mismatch_2</a>:
    <span class="keyword">forall</span> ty, m:<a href="#mem_44">mem</a> 'a, b ofs v m' ty'.
      <a href="#store_49">store</a> ty m b ofs v = <a href="option.html#Some_5">Some</a> m' -&gt;
      <span class="keyword">not</span> (<a href="#compat_9">compat</a> ty ty') -&gt;
      <a href="#valid_pointer_148">valid_pointer</a> ty' m b ofs -&gt;
      <span class="keyword">exists</span> a. <a href="#load_48">load</a> ty' m' b ofs = <a href="option.html#Some_5">Some</a> (<a href="#vundef_7">vundef</a> a)

  <span class="keyword">lemma</span> <a name="load_store_overlap_2_333">load_store_overlap_2</a>:
    <span class="keyword">forall</span> ty, m: <a href="#mem_44">mem</a> 'a ,b ofs v m' ty' ofs'.
      <a href="#store_49">store</a> ty m b ofs v = <a href="option.html#Some_5">Some</a> m' -&gt;
      ofs' &lt;&gt; ofs -&gt; ofs' <a href="int.html#infix%20+_19">+</a> <a href="#sizeof_10">sizeof</a> ty' <a href="int.html#infix%20%3E_24">&gt;</a> ofs -&gt; ofs <a href="int.html#infix%20+_19">+</a> <a href="#sizeof_10">sizeof</a> ty <a href="int.html#infix%20%3E_24">&gt;</a> ofs' -&gt;
      <a href="#valid_pointer_148">valid_pointer</a> ty' m b ofs' -&gt;
      <span class="keyword">exists</span> a. <a href="#load_48">load</a> ty' m' b ofs' = <a href="option.html#Some_5">Some</a> (<a href="#vundef_7">vundef</a> a)

  <span class="keyword">inductive</span> <a name="load_store_cases_341">load_store_cases</a> (ty1: <a href="set.html#fset_238">fset</a> 'a) (b1: <a href="#block_45">block</a> 'a) (ofs1: int) (ty2: <a href="set.html#fset_238">fset</a> 'a) (b2: <a href="#block_45">block</a> 'a) (ofs2: int) =
    | <a name="lsc_similar_342">lsc_similar</a>: <span class="keyword">forall</span> b1: <a href="#block_45">block</a> 'a, b2 ofs1 ofs2 ty1 ty2.
        b1 = b2 -&gt; ofs1 = ofs2 -&gt; <a href="#compat_9">compat</a> ty1 ty2 -&gt;
        <a href="#load_store_cases_341">load_store_cases</a> ty1 b1 ofs1 ty2 b2 ofs2
    | <a name="lsc_other_345">lsc_other</a>: <span class="keyword">forall</span> b1: <a href="#block_45">block</a> 'a, b2 ofs2 ty2 ofs1 ty1.
        b1 &lt;&gt; b2 \/ ofs2 <a href="int.html#infix%20+_19">+</a> <a href="#sizeof_10">sizeof</a> ty2 <a href="int.html#infix%20%3C=_25">&lt;=</a> ofs1 \/ ofs1 <a href="int.html#infix%20+_19">+</a> <a href="#sizeof_10">sizeof</a> ty1 <a href="int.html#infix%20%3C=_25">&lt;=</a> ofs2 -&gt;
        <a href="#load_store_cases_341">load_store_cases</a> ty1 b1 ofs1 ty2 b2 ofs2
    | <a name="lsc_overlap_348">lsc_overlap</a>: <span class="keyword">forall</span> b1: <a href="#block_45">block</a> 'a, b2, ofs1, ofs2, ty2, ty1.
        b1 = b2 -&gt; ofs1 &lt;&gt; ofs2 -&gt; ofs2 <a href="int.html#infix%20+_19">+</a> <a href="#sizeof_10">sizeof</a> ty2 <a href="int.html#infix%20%3E_24">&gt;</a> ofs1 -&gt; ofs1 <a href="int.html#infix%20+_19">+</a> <a href="#sizeof_10">sizeof</a> ty1 <a href="int.html#infix%20%3E_24">&gt;</a> ofs2 -&gt;
        <a href="#load_store_cases_341">load_store_cases</a> ty1 b1 ofs1 ty2 b2 ofs2
    | <a name="lsc_mismatch_351">lsc_mismatch</a>: <span class="keyword">forall</span> b1: <a href="#block_45">block</a> 'a, b2 ofs1 ofs2 ty1 ty2.
      b1 = b2 -&gt; ofs1 = ofs2 -&gt; <span class="keyword">not</span> <a href="#compat_9">compat</a> ty1 ty2 -&gt;
      <a href="#load_store_cases_341">load_store_cases</a> ty1 b1 ofs1 ty2 b2 ofs2

  <span class="keyword">lemma</span> <a name="load_store_classification_355">load_store_classification</a>:
    <span class="keyword">forall</span> ty1: <a href="set.html#fset_238">fset</a> 'a, b1 ofs1 ty2 b2 ofs2.
      <a href="#load_store_cases_341">load_store_cases</a> ty1 b1 ofs1 ty2 b2 ofs2

  <span class="keyword">lemma</span> <a name="load_store_characterization_lsc_similar_359">load_store_characterization_lsc_similar</a>:
    <span class="keyword">forall</span> ty: <a href="set.html#fset_238">fset</a> 'a, m1 b ofs v m2 ty' b' ofs'.
      <a href="#store_49">store</a> ty m1 b ofs v = <a href="option.html#Some_5">Some</a> m2 -&gt;
      <a href="#valid_pointer_148">valid_pointer</a> ty' m1 b' ofs' -&gt;
        <a href="#load_store_cases_341">load_store_cases</a> ty b ofs ty' b' ofs' /\ b = b' /\ ofs = ofs' /\ <a href="#compat_9">compat</a> ty ty' -&gt;
        <a href="#load_48">load</a> ty' m2 b' ofs' = <a href="option.html#Some_5">Some</a> (<a href="#convert_12">convert</a> ty' v)

  <span class="keyword">lemma</span> <a name="load_store_characterization_lsc_other_366">load_store_characterization_lsc_other</a>:
    <span class="keyword">forall</span> ty: <a href="set.html#fset_238">fset</a> 'a, m1 b ofs v m2 ty' b' ofs'.
      <a href="#store_49">store</a> ty m1 b ofs v = <a href="option.html#Some_5">Some</a> m2 -&gt;
      <a href="#valid_pointer_148">valid_pointer</a> ty' m1 b' ofs' -&gt;
        <a href="#load_store_cases_341">load_store_cases</a> ty b ofs ty' b' ofs' /\ (b &lt;&gt; b' \/ ofs' <a href="int.html#infix%20+_19">+</a> <a href="#sizeof_10">sizeof</a> ty' <a href="int.html#infix%20%3C=_25">&lt;=</a> ofs \/ ofs <a href="int.html#infix%20+_19">+</a> <a href="#sizeof_10">sizeof</a> ty <a href="int.html#infix%20%3C=_25">&lt;=</a> ofs') -&gt;
        <a href="#load_48">load</a> ty' m2 b' ofs' = <a href="#load_48">load</a> ty' m1 b' ofs'

  <span class="keyword">lemma</span> <a name="load_store_characterization_lsc_overlap_373">load_store_characterization_lsc_overlap</a>:
    <span class="keyword">forall</span> ty: <a href="set.html#fset_238">fset</a> 'a, m1 b ofs v m2 ty' b' ofs'.
      <a href="#store_49">store</a> ty m1 b ofs v = <a href="option.html#Some_5">Some</a> m2 -&gt;
      <a href="#valid_pointer_148">valid_pointer</a> ty' m1 b' ofs' -&gt;
        <a href="#load_store_cases_341">load_store_cases</a> ty b ofs ty' b' ofs' /\ b = b' /\ ofs &lt;&gt; ofs' /\ ofs' <a href="int.html#infix%20+_19">+</a> <a href="#sizeof_10">sizeof</a> ty' <a href="int.html#infix%20%3E_24">&gt;</a> ofs /\ ofs <a href="int.html#infix%20+_19">+</a> <a href="#sizeof_10">sizeof</a> ty <a href="int.html#infix%20%3E_24">&gt;</a> ofs' -&gt;
        <span class="keyword">exists</span> a. <a href="#load_48">load</a> ty' m2 b' ofs' = <a href="option.html#Some_5">Some</a> (<a href="#vundef_7">vundef</a> a)

  <span class="keyword">lemma</span> <a name="load_store_characterization_lsc_mismatch_380">load_store_characterization_lsc_mismatch</a>:
    <span class="keyword">forall</span> ty: <a href="set.html#fset_238">fset</a> 'a, m1 b ofs v m2 ty' b' ofs'.
      <a href="#store_49">store</a> ty m1 b ofs v = <a href="option.html#Some_5">Some</a> m2 -&gt;
      <a href="#valid_pointer_148">valid_pointer</a> ty' m1 b' ofs' -&gt;
        <a href="#load_store_cases_341">load_store_cases</a> ty b ofs ty' b' ofs' /\ b = b' /\ ofs = ofs' /\ <span class="keyword">not</span> <a href="#compat_9">compat</a> ty ty' -&gt;
        <span class="keyword">exists</span> a. <a href="#load_48">load</a> ty' m2 b' ofs' = <a href="option.html#Some_5">Some</a> (<a href="#vundef_7">vundef</a> a)

  <span class="keyword">lemma</span> <a name="store_same_domain_388">store_same_domain</a>:
    <span class="keyword">forall</span> ty1:<a href="set.html#fset_238">fset</a> 'a, m1 b1 ofs1 v1 m1' ty2 m2 b2 ofs2 v2 m2'.
      <a href="#store_49">store</a> ty1 m1 b1 ofs1 v1 = <a href="option.html#Some_5">Some</a> m1' -&gt;
      <a href="#store_49">store</a> ty2 m2 b2 ofs2 v2 = <a href="option.html#Some_5">Some</a> m2' -&gt;
      <a href="#same_domain_290">same_domain</a> m1 m2 -&gt;
      <a href="#same_domain_290">same_domain</a> m1' m2'

  <span class="keyword">lemma</span> <a name="free_same_domain_395">free_same_domain</a>:
    <span class="keyword">forall</span> m1: <a href="#mem_44">mem</a> 'a, b m1' m2 m2'.
      <a href="#free_50">free</a> m1 b = <a href="option.html#Some_5">Some</a> m1' -&gt;
      <a href="#free_50">free</a> m2 b = <a href="option.html#Some_5">Some</a> m2' -&gt;
      <a href="#same_domain_290">same_domain</a> m1 m2 -&gt;
      <a href="#same_domain_290">same_domain</a> m1' m2'

  <span class="keyword">lemma</span> <a name="free_not_valid_pointer_402">free_not_valid_pointer</a>:
    <span class="keyword">forall</span> m: <a href="#mem_44">mem</a> 'a, b m'.
      <a href="#free_50">free</a> m b = <a href="option.html#Some_5">Some</a> m' -&gt;
      <span class="keyword">forall</span> ty ofs. <span class="keyword">not</span> (<a href="#valid_pointer_148">valid_pointer</a> ty m' b ofs)

<span class="keyword">end</span>

<span class="keyword">module</span> <a name="Concrete_Mem_">Concrete_Mem</a>

  <span class="keyword">use</span> <span class="keyword">export</span> <a href="#Ref_Gen_Mem_Facts_">Ref_Gen_Mem_Facts</a>
  <span class="keyword">use</span> int.<a href="int.html#EuclideanDivision_">EuclideanDivision</a>

  <span class="keyword">function</span> <a name="update_415">update</a> (x: int) (v: 'a) (f: int -&gt; 'a): int -&gt; 'a =
    <span class="keyword">fun</span> y -&gt; <span class="keyword">if</span> y = x <span class="keyword">then</span> v <span class="keyword">else</span> f y

  <span class="keyword">lemma</span> <a name="update_s_418">update_s</a>:
    <span class="keyword">forall</span> x, v: <a href="set.html#fset_238">fset</a> 'a, f.
      <a href="#update_415">update</a> x v f x = v

  <span class="keyword">lemma</span> <a name="update_o_422">update_o</a>:
    <span class="keyword">forall</span> x, v: <a href="set.html#fset_238">fset</a> 'a, f y.
      y &lt;&gt; x -&gt; <a href="#update_415">update</a> x v f y = f y

  <span class="keyword">type</span> <a name="content_426">content</a> 'a = <a href="option.html#option_5">option</a> (<a href="set.html#fset_238">fset</a> 'a, <a href="#value_6">value</a> 'a)

  <span class="keyword">type</span> <a name="block__428">block_</a> = int

  <span class="keyword">type</span> <a name="mem__430">mem_</a> 'a = {
    <a name="nextblock_431">nextblock</a>: int;
    <a name="bounds__432">bounds_</a>: <a href="#block__428">block_</a> -&gt; (int,int);
    <a name="freed_433">freed</a>: <a href="#block__428">block_</a> -&gt; bool;
    <a name="contents_434">contents</a>: <a href="#block__428">block_</a> -&gt; int -&gt; <a href="#content_426">content</a> 'a
  }

  <span class="keyword">val</span> <a name="empty_mem_438">empty_mem</a> () : <a href="#mem__430">mem_</a> 'a
    <span class="keyword">ensures</span> { result.<a href="#nextblock_431">nextblock</a> = 1 }
    <span class="keyword">ensures</span> { result.<a href="#bounds__432">bounds_</a> = <span class="keyword">fun</span> b -&gt; (0,0) }
    <span class="keyword">ensures</span> { result.<a href="#freed_433">freed</a> = <span class="keyword">fun</span> b -&gt; <span class="keyword">false</span> }
    <span class="keyword">ensures</span> { result.<a href="#contents_434">contents</a> = <span class="keyword">fun</span> b ofs -&gt; <a href="option.html#None_5">None</a> }

  <span class="keyword">predicate</span> <a name="fresh_block__445">fresh_block_</a> (m: <a href="#mem__430">mem_</a> 'a) (b: <a href="#block__428">block_</a>) =
    b <a href="int.html#infix%20%3E=_26">&gt;=</a> <a href="#nextblock_431">nextblock</a> m

  <span class="keyword">predicate</span> <a name="valid_block__448">valid_block_</a> (m: <a href="#mem__430">mem_</a> 'a) (b: <a href="#block__428">block_</a>) =
    b <a href="int.html#infix%20%3C_21">&lt;</a> <a href="#nextblock_431">nextblock</a> m /\ <a href="#freed_433">freed</a> m b = <span class="keyword">false</span>

  <span class="keyword">lemma</span> <a name="valid_block_dec_451">valid_block_dec</a>:
    <span class="keyword">forall</span> m: <a href="#mem_44">mem</a> 'a, b. <a href="#valid_block_78">valid_block</a> m b \/ <span class="keyword">not</span> <a href="#valid_block_78">valid_block</a> m b

  <span class="keyword">predicate</span> <a name="valid_pointer__454">valid_pointer_</a> (ty: <a href="set.html#fset_238">fset</a> 'a) (m: <a href="#mem__430">mem_</a> 'a) (b: <a href="#block__428">block_</a>) (ofs: int) =
    <a href="#valid_block__448">valid_block_</a> m b
    /\ (<a href="#divide_26">divide</a> (<a href="#alignof_11">alignof</a> ty) ofs)
    /\ <a href="#fst_141">fst</a> (<a href="#bounds__432">bounds_</a> m b) <a href="int.html#infix%20%3C=_25">&lt;=</a> ofs
    /\ ofs <a href="int.html#infix%20+_19">+</a> <a href="#sizeof_10">sizeof</a> ty <a href="int.html#infix%20%3C=_25">&lt;=</a> <a href="#snd_145">snd</a> (<a href="#bounds__432">bounds_</a> m b)

  <span class="keyword">lemma</span> <a name="zdivide_Zmod_461">zdivide_Zmod</a>:
    <span class="keyword">forall</span> a b. b <a href="int.html#infix%20%3E_24">&gt;</a> 0 -&gt; ((<a href="#divide_26">divide</a> b a) &lt;-&gt; <a href="int.html#mod_101">mod</a> a b = 0)

  <span class="keyword">lemma</span> <a name="aligned_dec_464">aligned_dec</a>:
    <span class="keyword">forall</span> ty: <a href="set.html#fset_238">fset</a> 'a, ofs. (<a href="#divide_26">divide</a> (<a href="#alignof_11">alignof</a> ty) ofs) \/ <span class="keyword">not</span> (<a href="#divide_26">divide</a> (<a href="#alignof_11">alignof</a> ty) ofs)

  <span class="keyword">lemma</span> <a name="valid_pointer_dec_467">valid_pointer_dec</a>:
    <span class="keyword">forall</span> ty: <a href="set.html#fset_238">fset</a> 'a, m b ofs. <a href="#valid_pointer__454">valid_pointer_</a> ty m b ofs \/ <span class="keyword">not</span> <a href="#valid_pointer__454">valid_pointer_</a> ty m b ofs

  <span class="keyword">let</span> <span class="keyword">rec</span> <span class="keyword">function</span> <a name="check_cont_471">check_cont</a> (f: int -&gt; <a href="#content_426">content</a> 'a) (ofs: int) (n: int) : bool
    <span class="keyword">requires</span> { n <a href="int.html#infix%20%3E=_26">&gt;=</a> 0 }
    <span class="keyword">variant</span> { n }
  = <span class="keyword">if</span> n <a href="int.html#infix%20=_16">=</a> 0 <span class="keyword">then</span> <span class="keyword">true</span> <span class="keyword">else</span>
  <span class="keyword">match</span> f ofs <span class="keyword">with</span>
    | <a href="option.html#None_5">None</a> -&gt; check_cont f (ofs <a href="int.html#infix%20+_19">+</a> 1) (n<a href="int.html#infix%20-_23">-</a>1)
    | _ -&gt; <span class="keyword">false</span>
  <span class="keyword">end</span>

  <span class="keyword">lemma</span> <a name="check_cont_charact_480">check_cont_charact</a>:
    <span class="keyword">forall</span> f: (int -&gt; <a href="option.html#option_5">option</a> (<a href="set.html#fset_238">fset</a> 'a, <a href="set.html#fset_238">fset</a> 'a)) , n ofs.
      n <a href="int.html#infix%20%3E=_26">&gt;=</a> 0 -&gt;
      <span class="keyword">if</span> <a href="#check_cont_471">check_cont</a> f ofs n
      <span class="keyword">then</span> (<span class="keyword">forall</span> i. ofs <a href="int.html#infix%20%3C=_25">&lt;=</a> i <a href="int.html#infix%20%3C_21">&lt;</a> ofs <a href="int.html#infix%20+_19">+</a> n -&gt; f i = <a href="option.html#None_5">None</a>)
      <span class="keyword">else</span> (<span class="keyword">exists</span> i. ofs <a href="int.html#infix%20%3C=_25">&lt;=</a> i <a href="int.html#infix%20%3C_21">&lt;</a> ofs <a href="int.html#infix%20+_19">+</a> n /\ f i &lt;&gt; <a href="option.html#None_5">None</a>)

  <span class="keyword">lemma</span> <a name="check_cont_exten_487">check_cont_exten</a>:
    <span class="keyword">forall</span> f1: (int -&gt; <a href="option.html#option_5">option</a> (<a href="set.html#fset_238">fset</a> 'a, <a href="set.html#fset_238">fset</a> 'a)), f2 n ofs.
      n <a href="int.html#infix%20%3E=_26">&gt;=</a> 0 -&gt;
      (<span class="keyword">forall</span> i. ofs <a href="int.html#infix%20%3C=_25">&lt;=</a> i <a href="int.html#infix%20%3C_21">&lt;</a> ofs <a href="int.html#infix%20+_19">+</a> n -&gt; f2 i = f1 i) -&gt;
      <a href="#check_cont_471">check_cont</a> f2 ofs n = <a href="#check_cont_471">check_cont</a> f1 ofs n

  <span class="keyword">function</span> <a name="load_contents_493">load_contents</a> (a: 'a) (ty: <a href="set.html#fset_238">fset</a> 'a) (f: int -&gt; <a href="#content_426">content</a> 'a) (ofs: int) : <a href="#value_6">value</a> 'a
  = <span class="keyword">match</span> f ofs <span class="keyword">with</span>
    | <a href="option.html#Some_5">Some</a>(ty', v) -&gt;
        <span class="keyword">if</span> <a href="#compat_9">compat</a> ty' ty <span class="keyword">then</span>
          <span class="keyword">if</span> <a href="#check_cont_471">check_cont</a> f (ofs <a href="int.html#infix%20+_19">+</a> 1) (<a href="#sizeof_10">sizeof</a> ty <a href="int.html#infix%20-_23">-</a> 1)
          <span class="keyword">then</span> <a href="#convert_12">convert</a> ty v
          <span class="keyword">else</span> <a href="#vundef_7">vundef</a> a
        <span class="keyword">else</span> <a href="#vundef_7">vundef</a> a
    | _ -&gt; <a href="#vundef_7">vundef</a> a
    <span class="keyword">end</span>

  <span class="keyword">lemma</span> <a name="load_contents_exten_505">load_contents_exten</a>:
    <span class="keyword">forall</span> a, f1:(int -&gt; <a href="#content_426">content</a> 'a), f2: (int -&gt; <a href="#content_426">content</a> 'a), ty: <a href="set.html#fset_238">fset</a> 'a, ofs.
      (<span class="keyword">forall</span> i. ofs <a href="int.html#infix%20%3C=_25">&lt;=</a> i <a href="int.html#infix%20%3C_21">&lt;</a> ofs <a href="int.html#infix%20+_19">+</a> <a href="#sizeof_10">sizeof</a> ty -&gt; f2 i = f1 i) -&gt;
      <a href="#load_contents_493">load_contents</a> a ty f2 ofs = <a href="#load_contents_493">load_contents</a> a ty f1 ofs

  <span class="keyword">lemma</span> <a name="load_contents_1_510">load_contents_1</a>:
    <span class="keyword">forall</span> a:'a, ty f ofs ty' v.
      f ofs = <a href="option.html#Some_5">Some</a>(ty', v) -&gt;
      <a href="#compat_9">compat</a> ty' ty -&gt;
      (<span class="keyword">forall</span> i. ofs <a href="int.html#infix%20+_19">+</a> 1 <a href="int.html#infix%20%3C=_25">&lt;=</a> i <a href="int.html#infix%20%3C_21">&lt;</a> ofs <a href="int.html#infix%20+_19">+</a> <a href="#sizeof_10">sizeof</a> ty -&gt; f i = <a href="option.html#None_5">None</a>) -&gt;
      <a href="#load_contents_493">load_contents</a> a ty f ofs = <a href="#convert_12">convert</a> ty v

  <span class="keyword">lemma</span> <a name="load_contents_2_517">load_contents_2</a>:
    <span class="keyword">forall</span> a: 'a, ty f ofs.
      f ofs = <a href="option.html#None_5">None</a> -&gt;
      <a href="#load_contents_493">load_contents</a> a ty f ofs = <a href="#vundef_7">vundef</a> a

  <span class="keyword">lemma</span> <a name="load_contents_3_522">load_contents_3</a>:
    <span class="keyword">forall</span> a: 'a, ty f ofs ty' v.
      f ofs = <a href="option.html#Some_5">Some</a>(ty', v) -&gt;
      <span class="keyword">not</span> <a href="#compat_9">compat</a> ty' ty -&gt;
      <a href="#load_contents_493">load_contents</a> a ty f ofs = <a href="#vundef_7">vundef</a> a

  <span class="keyword">lemma</span> <a name="load_contents_4_528">load_contents_4</a>:
    <span class="keyword">forall</span> a: 'a, ty f ofs i.
      ofs <a href="int.html#infix%20+_19">+</a> 1 <a href="int.html#infix%20%3C=_25">&lt;=</a> i <a href="int.html#infix%20%3C_21">&lt;</a> ofs <a href="int.html#infix%20+_19">+</a> <a href="#sizeof_10">sizeof</a> ty -&gt; f i &lt;&gt; <a href="option.html#None_5">None</a> -&gt;
      <a href="#load_contents_493">load_contents</a> a ty f ofs = <a href="#vundef_7">vundef</a> a

  <span class="keyword">let</span> <span class="keyword">rec</span> <span class="keyword">ghost</span> <span class="keyword">function</span> <a name="set_cont_533">set_cont</a> (f: int -&gt; <a href="#content_426">content</a> 'a) (ofs: int) (n: int) : int -&gt; <a href="#content_426">content</a> 'a
    <span class="keyword">requires</span> { n <a href="int.html#infix%20%3E=_26">&gt;=</a> 0 }
    <span class="keyword">variant</span> { n }
  = <span class="keyword">if</span> n <a href="int.html#infix%20=_16">=</a> 0 <span class="keyword">then</span> f <span class="keyword">else</span>
    set_cont (<a href="#update_415">update</a> ofs <a href="option.html#None_5">None</a> f) (ofs <a href="int.html#infix%20+_19">+</a> 1) (n<a href="int.html#infix%20-_23">-</a>1)

  <span class="keyword">lemma</span> <a name="set_cont_outside_540">set_cont_outside</a>:
    <span class="keyword">forall</span> n, f:(int -&gt; <a href="option.html#option_5">option</a> (<a href="set.html#fset_238">fset</a> 'a, <a href="set.html#fset_238">fset</a> 'a)) , ofs i.
      n <a href="int.html#infix%20%3E=_26">&gt;=</a> 0 -&gt;
      i <a href="int.html#infix%20%3C_21">&lt;</a> ofs \/ i <a href="int.html#infix%20%3E=_26">&gt;=</a> ofs <a href="int.html#infix%20+_19">+</a> n -&gt; <a href="#set_cont_533">set_cont</a> f ofs n i = f i

  <span class="keyword">lemma</span> <a name="set_cont_inside_546">set_cont_inside</a>:
    <span class="keyword">forall</span> n , f:(int -&gt; <a href="option.html#option_5">option</a> (<a href="set.html#fset_238">fset</a> 'a, <a href="set.html#fset_238">fset</a> 'a)) , ofs i.
      ofs <a href="int.html#infix%20%3C=_25">&lt;=</a> i <a href="int.html#infix%20%3C_21">&lt;</a> ofs <a href="int.html#infix%20+_19">+</a> n -&gt; <a href="#set_cont_533">set_cont</a> f ofs n i = <a href="option.html#None_5">None</a>

  <span class="keyword">function</span> <a name="store_contents_550">store_contents</a> (f: int -&gt; <a href="#content_426">content</a> 'a) (ty: <a href="set.html#fset_238">fset</a> 'a) (ofs: int) (v: <a href="#value_6">value</a> 'a): int -&gt; <a href="#content_426">content</a> 'a =
    <a href="#set_cont_533">set_cont</a> (<a href="#update_415">update</a> ofs (<a href="option.html#Some_5">Some</a> (ty, v)) f) (ofs <a href="int.html#infix%20+_19">+</a> 1) (<a href="#sizeof_10">sizeof</a> ty <a href="int.html#infix%20-_23">-</a> 1)

  <span class="keyword">lemma</span> <a name="store_contents_at_553">store_contents_at</a>:
    <span class="keyword">forall</span> f:(int -&gt; <a href="option.html#option_5">option</a> (<a href="set.html#fset_238">fset</a> 'a, <a href="set.html#fset_238">fset</a> 'a)) , ty ofs v.
      <a href="#store_contents_550">store_contents</a> f ty ofs v ofs = <a href="option.html#Some_5">Some</a> (ty, v)

  <span class="keyword">lemma</span> <a name="store_contents_cont_557">store_contents_cont</a>:
    <span class="keyword">forall</span> f:(int -&gt; <a href="option.html#option_5">option</a> (<a href="set.html#fset_238">fset</a> 'a, <a href="set.html#fset_238">fset</a> 'a)), ty ofs v i.
      ofs <a href="int.html#infix%20%3C_21">&lt;</a> i <a href="int.html#infix%20%3C_21">&lt;</a> ofs <a href="int.html#infix%20+_19">+</a> <a href="#sizeof_10">sizeof</a> ty -&gt;
      <a href="#store_contents_550">store_contents</a> f ty ofs v i = <a href="option.html#None_5">None</a>

  <span class="keyword">lemma</span> <a name="store_contents_outside_562">store_contents_outside</a>:
    <span class="keyword">forall</span> f:(int -&gt; <a href="option.html#option_5">option</a> (<a href="set.html#fset_238">fset</a> 'a, <a href="set.html#fset_238">fset</a> 'a)), ty ofs v i.
      i <a href="int.html#infix%20%3C_21">&lt;</a> ofs \/ i <a href="int.html#infix%20%3E=_26">&gt;=</a> ofs <a href="int.html#infix%20+_19">+</a> <a href="#sizeof_10">sizeof</a> ty -&gt;
      <a href="#store_contents_550">store_contents</a> f ty ofs v i = f i

  <span class="keyword">lemma</span> <a name="load_store_contents_same_567">load_store_contents_same</a>:
    <span class="keyword">forall</span> f:(int -&gt; <a href="option.html#option_5">option</a> (<a href="set.html#fset_238">fset</a> 'a, <a href="set.html#fset_238">fset</a> 'a)), ty ty' ofs v a.
      <a href="#compat_9">compat</a> ty ty' -&gt;
      <a href="#load_contents_493">load_contents</a> a ty' (<a href="#store_contents_550">store_contents</a> f ty ofs v) ofs = <a href="#convert_12">convert</a> ty' v

  <span class="keyword">lemma</span> <a name="load_store_contents_disjoint_572">load_store_contents_disjoint</a>:
    <span class="keyword">forall</span> a: 'a, f ty ty' ofs ofs' v.
      ofs' <a href="int.html#infix%20+_19">+</a> <a href="#sizeof_10">sizeof</a> ty' <a href="int.html#infix%20%3C=_25">&lt;=</a> ofs \/ ofs <a href="int.html#infix%20+_19">+</a> <a href="#sizeof_10">sizeof</a> ty <a href="int.html#infix%20%3C=_25">&lt;=</a> ofs' -&gt;
      <a href="#load_contents_493">load_contents</a> a ty' (<a href="#store_contents_550">store_contents</a> f ty ofs v) ofs' =
      <a href="#load_contents_493">load_contents</a> a ty' f ofs'

  <span class="keyword">lemma</span> <a name="load_store_contents_mismatch_578">load_store_contents_mismatch</a>:
    <span class="keyword">forall</span> a:'a, f ty ty' ofs v.
      <span class="keyword">not</span> <a href="#compat_9">compat</a> ty ty' -&gt;
      <a href="#load_contents_493">load_contents</a> a ty' (<a href="#store_contents_550">store_contents</a> f ty ofs v) ofs = <a href="#vundef_7">vundef</a> a

  <span class="keyword">lemma</span> <a name="load_store_contents_overlap_583">load_store_contents_overlap</a>:
    <span class="keyword">forall</span> a:'a, f ty ty' ofs ofs' v.
      ofs' &lt;&gt; ofs -&gt; ofs' <a href="int.html#infix%20+_19">+</a> <a href="#sizeof_10">sizeof</a> ty' <a href="int.html#infix%20%3E_24">&gt;</a> ofs -&gt; ofs <a href="int.html#infix%20+_19">+</a> <a href="#sizeof_10">sizeof</a> ty <a href="int.html#infix%20%3E_24">&gt;</a> ofs' -&gt;
      <a href="#load_contents_493">load_contents</a> a ty' (<a href="#store_contents_550">store_contents</a> f ty ofs v) ofs' = <a href="#vundef_7">vundef</a> a

  <span class="keyword">function</span> <a name="enough_free_memory_589">enough_free_memory</a> (mem: <a href="#mem__430">mem_</a> 'a) (i: int) : bool

  <span class="keyword">function</span> <a name="alloc__591">alloc_</a> (m: <a href="#mem__430">mem_</a> 'a) (lo hi: int) : <a href="option.html#option_5">option</a> (<a href="#block__428">block_</a> , <a href="#mem__430">mem_</a> 'a) =
    <span class="keyword">if</span> <a href="#enough_free_memory_589">enough_free_memory</a> m (hi <a href="int.html#infix%20-_23">-</a> lo)
    <span class="keyword">then</span> <a href="option.html#Some_5">Some</a>(<a href="#nextblock_431">nextblock</a> m,
               { <a href="#nextblock_431">nextblock</a> = (<a href="#nextblock_431">nextblock</a> m <a href="int.html#infix%20+_19">+</a> 1);
                 <a href="#bounds__432">bounds_</a> = ( <a href="#update_415">update</a> (<a href="#nextblock_431">nextblock</a> m) (lo, hi) (<a href="#bounds__432">bounds_</a> m));
                <a href="#freed_433">freed</a> = (<a href="#update_415">update</a> (<a href="#nextblock_431">nextblock</a> m) <span class="keyword">false</span> (<a href="#freed_433">freed</a> m));
                <a href="#contents_434">contents</a> = (<a href="#update_415">update</a> (<a href="#nextblock_431">nextblock</a> m) (<span class="keyword">fun</span> (ofs: int) -&gt; <a href="option.html#None_5">None</a>) (<a href="#contents_434">contents</a> m)) } )
    <span class="keyword">else</span> <a href="option.html#None_5">None</a>

  <span class="keyword">function</span> <a name="load__601">load_</a> (a: 'a) (ty: <a href="set.html#fset_238">fset</a> 'a) (m: <a href="#mem__430">mem_</a> 'a) (b: <a href="#block__428">block_</a>) (ofs: int) : <a href="option.html#option_5">option</a> (<a href="#value_6">value</a> 'a) =
    <span class="keyword">if</span> <a href="#valid_pointer__454">valid_pointer_</a> ty m b ofs
    <span class="keyword">then</span> <a href="option.html#Some_5">Some</a> (<a href="#load_contents_493">load_contents</a> a ty (<a href="#contents_434">contents</a> m b) ofs)
    <span class="keyword">else</span> <a href="option.html#None_5">None</a>

  <span class="keyword">function</span> <a name="store__606">store_</a> (ty: <a href="set.html#fset_238">fset</a> 'a) (m: <a href="#mem__430">mem_</a> 'a) (b: <a href="#block__428">block_</a>) (ofs: int) (v: <a href="#value_6">value</a> 'a) : <a href="option.html#option_5">option</a> (<a href="#mem__430">mem_</a> 'a) =
    <span class="keyword">if</span> <a href="#valid_pointer__454">valid_pointer_</a> ty m b ofs
    <span class="keyword">then</span> <a href="option.html#Some_5">Some</a>( { <a href="#nextblock_431">nextblock</a> = (<a href="#nextblock_431">nextblock</a> m);
                 <a href="#bounds__432">bounds_</a> = (<a href="#bounds__432">bounds_</a> m);
                 <a href="#freed_433">freed</a> = (<a href="#freed_433">freed</a> m);
                 <a href="#contents_434">contents</a> = (<a href="#update_415">update</a> b (<a href="#store_contents_550">store_contents</a> (<a href="#contents_434">contents</a> m b) ty ofs v) (<a href="#contents_434">contents</a> m))
                })
    <span class="keyword">else</span> <a href="option.html#None_5">None</a>

  <span class="keyword">function</span> <a name="free__615">free_</a> (m: <a href="#mem__430">mem_</a> 'a) (b: <a href="#block__428">block_</a>) : <a href="option.html#option_5">option</a> (<a href="#mem__430">mem_</a> 'a) =
    <span class="keyword">if</span> <a href="#freed_433">freed</a> m b
    <span class="keyword">then</span> <a href="option.html#None_5">None</a>
    <span class="keyword">else</span> <a href="option.html#Some_5">Some</a>( { <a href="#nextblock_431">nextblock</a> = (<a href="#nextblock_431">nextblock</a> m);
                 <a href="#bounds__432">bounds_</a> = (<a href="#update_415">update</a> b (0,0) (<a href="#bounds__432">bounds_</a> m));
                 <a href="#freed_433">freed</a> = (<a href="#update_415">update</a> b <span class="keyword">true</span> (<a href="#freed_433">freed</a> m));
                 <a href="#contents_434">contents</a> = (<a href="#contents_434">contents</a> m)
                })

  <span class="keyword">lemma</span> <a name="alloc_result_bounds__624">alloc_result_bounds_</a>:
    <span class="keyword">forall</span> m: <a href="#mem__430">mem_</a> 'a, lo hi b m'.
      <a href="#alloc__591">alloc_</a> m lo hi = <a href="option.html#Some_5">Some</a>(b, m') -&gt; <a href="#bounds__432">bounds_</a> m' b = (lo, hi)

  <span class="keyword">lemma</span> <a name="alloc_bounds_inv__628">alloc_bounds_inv_</a>:
    <span class="keyword">forall</span> m: <a href="#mem__430">mem_</a> 'a, lo hi b m' b'.
      <a href="#alloc__591">alloc_</a> m lo hi = <a href="option.html#Some_5">Some</a>(b, m') -&gt; b' &lt;&gt; b -&gt; <a href="#bounds__432">bounds_</a> m' b' = <a href="#bounds__432">bounds_</a> m b'

  <span class="keyword">lemma</span> <a name="store_bounds_inv__632">store_bounds_inv_</a>:
    <span class="keyword">forall</span> ty, m: <a href="#mem__430">mem_</a> 'a, b ofs v m' b'.
      <a href="#store__606">store_</a> ty m b ofs v = <a href="option.html#Some_5">Some</a> m' -&gt; <a href="#bounds__432">bounds_</a> m' b' = <a href="#bounds__432">bounds_</a> m b'

  <span class="keyword">lemma</span> <a name="free_bounds_inv__636">free_bounds_inv_</a>:
    <span class="keyword">forall</span> m: <a href="#mem__430">mem_</a> 'a, b m' b'.
      <a href="#free__615">free_</a> m b = <a href="option.html#Some_5">Some</a> m' -&gt; b' &lt;&gt; b -&gt; <a href="#bounds__432">bounds_</a> m' b' = <a href="#bounds__432">bounds_</a> m b'

  <span class="keyword">lemma</span> <a name="fresh_valid_block_exclusive__640">fresh_valid_block_exclusive_</a>:
    <span class="keyword">forall</span> m: <a href="#mem__430">mem_</a> 'a, b.
      <a href="#fresh_block__445">fresh_block_</a> m b -&gt; <a href="#valid_block__448">valid_block_</a> m b -&gt; False

  <span class="keyword">lemma</span> <a name="alloc_fresh_block__645">alloc_fresh_block_</a>:
    <span class="keyword">forall</span> m:<a href="#mem__430">mem_</a> 'a, lo hi b m' b'.
      <a href="#alloc__591">alloc_</a> m lo hi = <a href="option.html#Some_5">Some</a>(b, m') -&gt;
      (<a href="#fresh_block__445">fresh_block_</a> m' b' &lt;-&gt; b &lt;&gt; b' /\ <a href="#fresh_block__445">fresh_block_</a> m b')

  <span class="keyword">lemma</span> <a name="alloc_fresh_block_2__650">alloc_fresh_block_2_</a>:
    <span class="keyword">forall</span> m:<a href="#mem__430">mem_</a> 'a, lo hi b m'.
      <a href="#alloc__591">alloc_</a> m lo hi = <a href="option.html#Some_5">Some</a>(b, m') -&gt; <a href="#fresh_block__445">fresh_block_</a> m b

  <span class="keyword">lemma</span> <a name="store_inversion_654">store_inversion</a>:
    <span class="keyword">forall</span> ty: <a href="set.html#fset_238">fset</a> 'a, m b ofs v m'.
      <a href="#store__606">store_</a> ty m b ofs v = <a href="option.html#Some_5">Some</a> m' -&gt;
      <a href="#valid_pointer__454">valid_pointer_</a> ty m b ofs /\
      m' = { <a href="#nextblock_431">nextblock</a> = (<a href="#nextblock_431">nextblock</a> m);
             <a href="#bounds__432">bounds_</a> = (<a href="#bounds__432">bounds_</a> m);
             <a href="#freed_433">freed</a> = (<a href="#freed_433">freed</a> m);
             <a href="#contents_434">contents</a> = (<a href="#update_415">update</a> b (<a href="#store_contents_550">store_contents</a> (<a href="#contents_434">contents</a> m b) ty ofs v) (<a href="#contents_434">contents</a> m))
           }

  <span class="keyword">lemma</span> <a name="store_fresh_block__664">store_fresh_block_</a>:
    <span class="keyword">forall</span> m: <a href="#mem__430">mem_</a> 'a, chunk b ofs v m' b'.
      <a href="#store__606">store_</a> chunk m b ofs v = <a href="option.html#Some_5">Some</a> m' -&gt;
      (<a href="#fresh_block__445">fresh_block_</a> m' b' &lt;-&gt; <a href="#fresh_block__445">fresh_block_</a> m b')

  <span class="keyword">lemma</span> <a name="free_fresh_block__669">free_fresh_block_</a>:
    <span class="keyword">forall</span> m: <a href="#mem__430">mem_</a> 'a, b m' b'.
      <a href="#free__615">free_</a> m b = <a href="option.html#Some_5">Some</a> m' -&gt;
      (<a href="#fresh_block__445">fresh_block_</a> m' b' &lt;-&gt; <a href="#fresh_block__445">fresh_block_</a> m b')

  <span class="keyword">lemma</span> <a name="alloc_valid_block_674">alloc_valid_block</a>:
    <span class="keyword">forall</span> m: <a href="#mem__430">mem_</a> 'a, lo hi b m' b'.
      <a href="#alloc__591">alloc_</a> m lo hi = <a href="option.html#Some_5">Some</a>(b, m') -&gt;
      (<a href="#valid_block__448">valid_block_</a> m' b' &lt;-&gt; b' = b \/ <a href="#valid_block__448">valid_block_</a> m b')

  <span class="keyword">lemma</span> <a name="alloc_not_valid_block__679">alloc_not_valid_block_</a>:
    <span class="keyword">forall</span> m: <a href="#mem__430">mem_</a> 'a, lo hi b m'.
    <a href="#alloc__591">alloc_</a> m lo hi = <a href="option.html#Some_5">Some</a>(b, m') -&gt; <span class="keyword">not</span> (<a href="#valid_block__448">valid_block_</a> m b)

  <span class="keyword">lemma</span> <a name="load_valid_block__683">load_valid_block_</a>:
    <span class="keyword">forall</span> ty:<a href="set.html#fset_238">fset</a> 'a, a m b ofs v.
    <a href="#load__601">load_</a> a ty m b ofs = <a href="option.html#Some_5">Some</a> v -&gt; <a href="#valid_block__448">valid_block_</a> m b

  <span class="keyword">lemma</span> <a name="store_valid_block__687">store_valid_block_</a>:
    <span class="keyword">forall</span> ty: <a href="set.html#fset_238">fset</a> 'a, m b ofs v m'.
    <a href="#store__606">store_</a> ty m b ofs v = <a href="option.html#Some_5">Some</a> m' -&gt; <a href="#valid_block__448">valid_block_</a> m b

  <span class="keyword">lemma</span> <a name="store_valid_block_inv__691">store_valid_block_inv_</a>:
    <span class="keyword">forall</span> ty: <a href="set.html#fset_238">fset</a> 'a, m b ofs v m' b'.
    <a href="#store__606">store_</a> ty m b ofs v = <a href="option.html#Some_5">Some</a> m' -&gt; (<a href="#valid_block__448">valid_block_</a> m' b' &lt;-&gt; <a href="#valid_block__448">valid_block_</a> m b')

  <span class="keyword">lemma</span> <a name="free_valid_block__695">free_valid_block_</a>:
    <span class="keyword">forall</span> m: <a href="#mem__430">mem_</a> 'a, b m' b'.
    <a href="#free__615">free_</a> m b = <a href="option.html#Some_5">Some</a> m' -&gt; b' &lt;&gt; b -&gt; (<a href="#valid_block__448">valid_block_</a> m' b' &lt;-&gt; <a href="#valid_block__448">valid_block_</a> m b')

  <span class="keyword">lemma</span> <a name="store_valid_pointer_inv__699">store_valid_pointer_inv_</a>:
    <span class="keyword">forall</span> ty: <a href="set.html#fset_238">fset</a> 'a, m b ofs v m' ty' b' ofs'.
    <a href="#store__606">store_</a> ty m b ofs v = <a href="option.html#Some_5">Some</a> m' -&gt;
    (<a href="#valid_pointer__454">valid_pointer_</a> ty' m' b' ofs' &lt;-&gt; <a href="#valid_pointer__454">valid_pointer_</a> ty' m b' ofs')

  <span class="keyword">lemma</span> <a name="alloc_valid_pointer_inv__704">alloc_valid_pointer_inv_</a>:
    <span class="keyword">forall</span> m: <a href="#mem__430">mem_</a> 'a, lo hi b m' ty b' ofs.
    <a href="#alloc__591">alloc_</a> m lo hi = <a href="option.html#Some_5">Some</a>(b, m') -&gt; b' &lt;&gt; b -&gt;
    (<a href="#valid_pointer__454">valid_pointer_</a> ty m b' ofs &lt;-&gt; <a href="#valid_pointer__454">valid_pointer_</a> ty m' b' ofs)

  <span class="keyword">lemma</span> <a name="free_valid_pointer_inv__709">free_valid_pointer_inv_</a>:
    <span class="keyword">forall</span> m: <a href="#mem__430">mem_</a> 'a, b m' ty b' ofs.
    <a href="#free__615">free_</a> m b = <a href="option.html#Some_5">Some</a> m' -&gt; b' &lt;&gt; b -&gt;
    (<a href="#valid_pointer__454">valid_pointer_</a> ty m' b' ofs &lt;-&gt; <a href="#valid_pointer__454">valid_pointer_</a> ty m b' ofs)

  <span class="keyword">lemma</span> <a name="load_alloc_other__714">load_alloc_other_</a>:
    <span class="keyword">forall</span> m: <a href="#mem__430">mem_</a> 'a, a lo hi b m' ty b' ofs.
    <a href="#alloc__591">alloc_</a> m lo hi = <a href="option.html#Some_5">Some</a> (b, m') -&gt;
    b' &lt;&gt; b -&gt;
    <a href="#load__601">load_</a> a ty m' b' ofs = <a href="#load__601">load_</a> a ty m b' ofs

  <span class="keyword">lemma</span> <a name="valid_pointer_compat__720">valid_pointer_compat_</a>:
    <span class="keyword">forall</span> ty, m: <a href="#mem__430">mem_</a> 'a, b ofs ty'.
    <a href="#compat_9">compat</a> ty ty' -&gt;
    (<a href="#valid_pointer__454">valid_pointer_</a> ty m b ofs &lt;-&gt; <a href="#valid_pointer__454">valid_pointer_</a> ty' m b ofs)

  <span class="keyword">lemma</span> <a name="load_store_same__725">load_store_same_</a>:
    <span class="keyword">forall</span> ty:<a href="set.html#fset_238">fset</a> 'a, m: <a href="#mem__430">mem_</a> 'a, a b ofs v m' ty'.
    <a href="#store__606">store_</a> ty m b ofs v = <a href="option.html#Some_5">Some</a> m' -&gt;
    <a href="#compat_9">compat</a> ty ty' -&gt;
    <a href="#load__601">load_</a> a ty' m' b ofs = <a href="option.html#Some_5">Some</a> (<a href="#convert_12">convert</a> ty' v)

  <span class="keyword">lemma</span> <a name="load_store_disjoint__731">load_store_disjoint_</a>:
    <span class="keyword">forall</span> ty, m: <a href="#mem__430">mem_</a> 'a, a b ofs v m' ty' b' ofs'.
    <a href="#store__606">store_</a> ty m b ofs v = <a href="option.html#Some_5">Some</a> m' -&gt;
    b' &lt;&gt; b \/ ofs' <a href="int.html#infix%20+_19">+</a> <a href="#sizeof_10">sizeof</a> ty' <a href="int.html#infix%20%3C=_25">&lt;=</a> ofs \/ ofs <a href="int.html#infix%20+_19">+</a> <a href="#sizeof_10">sizeof</a> ty <a href="int.html#infix%20%3C=_25">&lt;=</a> ofs' -&gt;
    <a href="#load__601">load_</a> a ty' m' b' ofs' = <a href="#load__601">load_</a> a ty' m b' ofs'

  <span class="keyword">lemma</span> <a name="load_free_other__737">load_free_other_</a>:
    <span class="keyword">forall</span> m: <a href="#mem__430">mem_</a> 'a, a b m' ty b' ofs.
    <a href="#free__615">free_</a> m b = <a href="option.html#Some_5">Some</a> m' -&gt;
    b' &lt;&gt; b -&gt;
    <a href="#load__601">load_</a> a ty m' b' ofs = <a href="#load__601">load_</a> a ty m b' ofs

  <span class="keyword">lemma</span> <a name="load_alloc_same__743">load_alloc_same_</a>:
    <span class="keyword">forall</span> a: 'a, m lo hi b m' ty ofs v.
    <a href="#alloc__591">alloc_</a> m lo hi = <a href="option.html#Some_5">Some</a> (b, m') -&gt;
    <a href="#load__601">load_</a> a ty m' b ofs = <a href="option.html#Some_5">Some</a> v -&gt;
    v = (<a href="#vundef_7">vundef</a> a)

  <span class="keyword">lemma</span> <a name="load_store_mismatch__749">load_store_mismatch_</a>:
    <span class="keyword">forall</span> a: 'a,ty m b ofs v m' ty' v'.
    <a href="#store__606">store_</a> ty m b ofs v = <a href="option.html#Some_5">Some</a> m' -&gt;
    <span class="keyword">not</span> (<a href="#compat_9">compat</a> ty ty') -&gt;
    <a href="#load__601">load_</a> a ty' m' b ofs = <a href="option.html#Some_5">Some</a> v' -&gt;
    v' = (<a href="#vundef_7">vundef</a> a)

  <span class="keyword">lemma</span> <a name="load_store_overlap__756">load_store_overlap_</a>:
    <span class="keyword">forall</span> a: 'a, ty m b ofs v m' ty' ofs' v'.
    <a href="#store__606">store_</a> ty m b ofs v = <a href="option.html#Some_5">Some</a> m' -&gt;
    ofs' &lt;&gt; ofs -&gt; ofs' <a href="int.html#infix%20+_19">+</a> <a href="#sizeof_10">sizeof</a> ty' <a href="int.html#infix%20%3E_24">&gt;</a> ofs -&gt; ofs <a href="int.html#infix%20+_19">+</a> <a href="#sizeof_10">sizeof</a> ty <a href="int.html#infix%20%3E_24">&gt;</a> ofs' -&gt;
    <a href="#load__601">load_</a> a ty' m' b ofs' = <a href="option.html#Some_5">Some</a> v' -&gt;
    v' = (<a href="#vundef_7">vundef</a> a)

  <span class="keyword">predicate</span> <a name="same_domain__763">same_domain_</a> (m1 m2: <a href="#mem__430">mem_</a> 'a) =
    <span class="keyword">forall</span> b. <a href="#fresh_block__445">fresh_block_</a> m1 b &lt;-&gt; <a href="#fresh_block__445">fresh_block_</a> m2 b

  <span class="keyword">lemma</span> <a name="same_domain_same_nextblock_766">same_domain_same_nextblock</a>:
    <span class="keyword">forall</span> m1: <a href="#mem__430">mem_</a> 'a, m2. <a href="#same_domain__763">same_domain_</a> m1 m2 -&gt; <a href="#nextblock_431">nextblock</a> m2 = <a href="#nextblock_431">nextblock</a> m1

  <span class="keyword">lemma</span> <a name="alloc_same_domain__769">alloc_same_domain_</a>:
    <span class="keyword">forall</span> m1: <a href="#mem__430">mem_</a> 'a, lo1 hi1 b1 m1' m2 lo2 hi2 b2 m2'.
    <a href="#alloc__591">alloc_</a> m1 lo1 hi1 = <a href="option.html#Some_5">Some</a>(b1, m1') -&gt;
    <a href="#alloc__591">alloc_</a> m2 lo2 hi2 = <a href="option.html#Some_5">Some</a>(b2, m2') -&gt;
    <a href="#same_domain__763">same_domain_</a> m1 m2 -&gt;
    b1 = b2 /\ <a href="#same_domain__763">same_domain_</a> m1' m2'

  <span class="keyword">lemma</span> <a name="valid_block_free__776">valid_block_free_</a>:
    <span class="keyword">forall</span> m: <a href="#mem__430">mem_</a> 'a, b.
    <a href="#valid_block__448">valid_block_</a> m b -&gt; <span class="keyword">exists</span> m'. <a href="#free__615">free_</a> m b = <a href="option.html#Some_5">Some</a> m'

  <span class="keyword">lemma</span> <a name="valid_pointer_store__780">valid_pointer_store_</a>:
    <span class="keyword">forall</span> ty, m: <a href="#mem__430">mem_</a> 'a, b ofs v.
    <a href="#valid_pointer__454">valid_pointer_</a> ty m b ofs -&gt;
    <span class="keyword">exists</span> m'. <a href="#store__606">store_</a> ty m b ofs v = <a href="option.html#Some_5">Some</a> m'

  <span class="keyword">lemma</span> <a name="store_valid_pointer__785">store_valid_pointer_</a>:
    <span class="keyword">forall</span> ty, m: <a href="#mem__430">mem_</a> 'a, b ofs v m'.
    <a href="#store__606">store_</a> ty m b ofs v = <a href="option.html#Some_5">Some</a> m' -&gt; <a href="#valid_pointer__454">valid_pointer_</a> ty m b ofs

  <span class="keyword">lemma</span> <a name="valid_pointer_load__789">valid_pointer_load_</a>:
    <span class="keyword">forall</span> ty, m: <a href="#mem__430">mem_</a> 'a, a b ofs.
    <a href="#valid_pointer__454">valid_pointer_</a> ty m b ofs -&gt;
    <span class="keyword">exists</span> v. <a href="#load__601">load_</a> a ty m b ofs = <a href="option.html#Some_5">Some</a> v

  <span class="keyword">lemma</span> <a name="load_valid_pointer__794">load_valid_pointer_</a>:
    <span class="keyword">forall</span> a: 'a,ty m b ofs v.
    <a href="#load__601">load_</a> a ty m b ofs = <a href="option.html#Some_5">Some</a> v -&gt; <a href="#valid_pointer__454">valid_pointer_</a> ty m b ofs

  <span class="keyword">lemma</span> <a name="free_not_valid_block__798">free_not_valid_block_</a>:
    <span class="keyword">forall</span> m:<a href="#mem__430">mem_</a> 'a, b m'.
    <a href="#free__615">free_</a> m b = <a href="option.html#Some_5">Some</a> m' -&gt;
    <span class="keyword">not</span> (<a href="#valid_block__448">valid_block_</a> m' b)

  <span class="keyword">lemma</span> <a name="free_same_bounds__803">free_same_bounds_</a>:
    <span class="keyword">forall</span> m: <a href="#mem__430">mem_</a> 'a, b m'.
    <a href="#free__615">free_</a> m b = <a href="option.html#Some_5">Some</a> m' -&gt;
    <a href="#fst_141">fst</a>(<a href="#bounds__432">bounds_</a> m' b) = <a href="#snd_145">snd</a>(<a href="#bounds__432">bounds_</a> m' b)

<span class="keyword">end</span>

<span class="keyword">module</span> <a name="Rel_Mem_">Rel_Mem</a>

  <span class="keyword">use</span> <span class="keyword">export</span> <a href="#Concrete_Mem_">Concrete_Mem</a>
  <span class="keyword">use</span> list.<a href="list.html#List_">List</a>
  <span class="keyword">use</span> list.<a href="list.html#Mem_">Mem</a>

  <span class="keyword">type</span> <a name="embedding_816">embedding</a> = (<a href="#block__428">block_</a> -&gt; <a href="option.html#option_5">option</a> (<a href="#block__428">block_</a>, int))

  <span class="keyword">function</span> <a name="val_emb_818">val_emb</a> (e: <a href="#embedding_816">embedding</a>) (v1: <a href="#value_6">value</a> 'a) (v2: <a href="#value_6">value</a> 'a) : bool

  <span class="keyword">predicate</span> <a name="mem_emb_820">mem_emb</a> (emb: <a href="#embedding_816">embedding</a>) (m1 m2: <a href="#mem__430">mem_</a> 'a) =
    <span class="keyword">forall</span> a: 'a, ty b1 ofs v1 b2 delta.
      emb b1 = <a href="option.html#Some_5">Some</a>(b2, delta) -&gt;
      <a href="#load__601">load_</a> a ty m1 b1 ofs = <a href="option.html#Some_5">Some</a> v1 -&gt;
      <span class="keyword">exists</span> v2. <a href="#load__601">load_</a> a ty m2 b2 (ofs <a href="int.html#infix%20+_19">+</a> delta) = <a href="option.html#Some_5">Some</a> v2 /\ <a href="#val_emb_818">val_emb</a> emb v1 v2

  <span class="keyword">lemma</span> <a name="valid_pointer_emb_826">valid_pointer_emb</a>:
    <span class="keyword">forall</span> emb, m1: <a href="#mem__430">mem_</a> 'a, m2 ty b1 ofs b2 delta.
      emb b1 = <a href="option.html#Some_5">Some</a>(b2, delta) -&gt;
      <a href="#mem_emb_820">mem_emb</a> emb m1 m2 -&gt;
      <a href="#valid_pointer__454">valid_pointer_</a> ty m1 b1 ofs -&gt;
      <a href="#valid_pointer__454">valid_pointer_</a> ty m2 b2 (ofs <a href="int.html#infix%20+_19">+</a> delta)

  <span class="keyword">lemma</span> <a name="store_unmapped_emb_833">store_unmapped_emb</a>:
    <span class="keyword">forall</span> emb, m1: <a href="#mem__430">mem_</a> 'a, m2 b ofs v ty m1'.
      <a href="#mem_emb_820">mem_emb</a> emb m1 m2 -&gt;
      emb b = <a href="option.html#None_5">None</a> -&gt;
      <a href="#store__606">store_</a> ty m1 b ofs v = <a href="option.html#Some_5">Some</a> m1' -&gt;
      <a href="#mem_emb_820">mem_emb</a> emb m1' m2

  <span class="keyword">lemma</span> <a name="store_outside_emb_841">store_outside_emb</a>:
  <span class="keyword">forall</span> emb, m1: <a href="#mem__430">mem_</a> 'a, m2 ty b ofs v m2'.
  <a href="#mem_emb_820">mem_emb</a> emb m1 m2 -&gt;
  (<span class="keyword">forall</span> b' delta.
     emb b' = <a href="option.html#Some_5">Some</a>(b, delta) -&gt;
     <a href="#snd_145">snd</a>(<a href="#bounds__432">bounds_</a> m1 b') <a href="int.html#infix%20+_19">+</a> delta <a href="int.html#infix%20%3C=_25">&lt;=</a> ofs \/ ofs <a href="int.html#infix%20+_19">+</a> <a href="#sizeof_10">sizeof</a> ty <a href="int.html#infix%20%3C=_25">&lt;=</a> <a href="#fst_141">fst</a>(<a href="#bounds__432">bounds_</a> m1 b') <a href="int.html#infix%20+_19">+</a> delta) -&gt;
  <a href="#store__606">store_</a> ty m2 b ofs v = <a href="option.html#Some_5">Some</a> m2' -&gt;
  <a href="#mem_emb_820">mem_emb</a> emb m1 m2'

  <span class="keyword">predicate</span> <a name="embedding_no_overlap_850">embedding_no_overlap</a> (emb: <a href="#embedding_816">embedding</a>) (m: <a href="#mem__430">mem_</a> 'a) =
    <span class="keyword">forall</span> b1 b1' delta1 b2 b2' delta2.
    b1 &lt;&gt; b2 -&gt;
    emb b1 = <a href="option.html#Some_5">Some</a> (b1', delta1) -&gt;
    emb b2 = <a href="option.html#Some_5">Some</a> (b2', delta2) -&gt;
    b1' &lt;&gt; b2'
    \/ <a href="#fst_141">fst</a>(<a href="#bounds__432">bounds_</a> m b1) <a href="int.html#infix%20%3E=_26">&gt;=</a> <a href="#snd_145">snd</a>(<a href="#bounds__432">bounds_</a> m b1)
    \/ <a href="#fst_141">fst</a>(<a href="#bounds__432">bounds_</a> m b2) <a href="int.html#infix%20%3E=_26">&gt;=</a> <a href="#snd_145">snd</a>(<a href="#bounds__432">bounds_</a> m b2)
    \/ <a href="#snd_145">snd</a>(<a href="#bounds__432">bounds_</a> m b1) <a href="int.html#infix%20+_19">+</a> delta1 <a href="int.html#infix%20%3C=_25">&lt;=</a> <a href="#fst_141">fst</a>(<a href="#bounds__432">bounds_</a> m b2) <a href="int.html#infix%20+_19">+</a> delta2
    \/ <a href="#snd_145">snd</a>(<a href="#bounds__432">bounds_</a> m b2) <a href="int.html#infix%20+_19">+</a> delta2 <a href="int.html#infix%20%3C=_25">&lt;=</a> <a href="#fst_141">fst</a>(<a href="#bounds__432">bounds_</a> m b1) <a href="int.html#infix%20+_19">+</a> delta1

  <span class="keyword">lemma</span> <a name="store_mapped_emb_861">store_mapped_emb</a>:
    <span class="keyword">forall</span> a: 'a, emb, m1: <a href="#mem__430">mem_</a> 'a, m2 b1 ofs b2 delta v1 v2 ty m1'.
      <a href="#mem_emb_820">mem_emb</a> emb m1 m2 -&gt;
      <a href="#embedding_no_overlap_850">embedding_no_overlap</a> emb m1 -&gt;
      <a href="#val_emb_818">val_emb</a> emb (<a href="#vundef_7">vundef</a> a) (<a href="#vundef_7">vundef</a> a) -&gt;
      emb b1 = <a href="option.html#Some_5">Some</a>(b2, delta) -&gt;
      <a href="#store__606">store_</a> ty m1 b1 ofs v1 = <a href="option.html#Some_5">Some</a> m1' -&gt;
      (<span class="keyword">forall</span> ty'. <a href="#compat_9">compat</a> ty ty' -&gt;
        <a href="#val_emb_818">val_emb</a> emb (<a href="#convert_12">convert</a> ty' v1) (<a href="#convert_12">convert</a> ty' v2)) -&gt;
      <span class="keyword">exists</span> m2'.
      <a href="#store__606">store_</a> ty m2 b2 (ofs <a href="int.html#infix%20+_19">+</a> delta) v2 = <a href="option.html#Some_5">Some</a> m2' /\ <a href="#mem_emb_820">mem_emb</a> emb m1' m2'

  <span class="keyword">lemma</span> <a name="alignment_shift_874">alignment_shift</a>:
    <span class="keyword">forall</span> ty: <a href="set.html#fset_238">fset</a> 'a, ofs delta.
      (<a href="#divide_26">divide</a> (<a href="#alignof_11">alignof</a> ty) ofs) -&gt; (<a href="#divide_26">divide</a> (<a href="#max_alignment_24">max_alignment</a>) delta) -&gt;
      (<a href="#divide_26">divide</a> (<a href="#alignof_11">alignof</a> ty) (ofs <a href="int.html#infix%20+_19">+</a> delta))

  <span class="keyword">lemma</span> <a name="alloc_parallel_emb_879">alloc_parallel_emb</a>:
    <span class="keyword">forall</span> a: 'a, emb, m1 : <a href="#mem__430">mem_</a> 'a, m2 lo1 hi1 m1' b1 lo2 hi2 m2' b2 delta.
      <a href="#mem_emb_820">mem_emb</a> emb m1 m2 -&gt;
      <a href="#alloc__591">alloc_</a> m1 lo1 hi1 = <a href="option.html#Some_5">Some</a>(b1, m1') -&gt;
      <a href="#alloc__591">alloc_</a> m2 lo2 hi2 = <a href="option.html#Some_5">Some</a>(b2, m2') -&gt;
      emb b1 = <a href="option.html#Some_5">Some</a>(b2, delta) -&gt;
      lo2 <a href="int.html#infix%20%3C=_25">&lt;=</a> lo1 <a href="int.html#infix%20+_19">+</a> delta -&gt; hi1 <a href="int.html#infix%20+_19">+</a> delta <a href="int.html#infix%20%3C=_25">&lt;=</a> hi2 -&gt;
      (<a href="#divide_26">divide</a> <a href="#max_alignment_24">max_alignment</a> delta) -&gt;
      <a href="#val_emb_818">val_emb</a> emb (<a href="#vundef_7">vundef</a> a) (<a href="#vundef_7">vundef</a> a) -&gt;
      <a href="#mem_emb_820">mem_emb</a> emb m1' m2'

  <span class="keyword">lemma</span> <a name="alloc_right_emb_890">alloc_right_emb</a>:
    <span class="keyword">forall</span> emb, m1: <a href="#mem__430">mem_</a> 'a, m2 lo hi b2 m2'.
      <a href="#mem_emb_820">mem_emb</a> emb m1 m2 -&gt;
      <a href="#alloc__591">alloc_</a> m2 lo hi = <a href="option.html#Some_5">Some</a>(b2, m2') -&gt;
      <a href="#mem_emb_820">mem_emb</a> emb m1 m2'

  <span class="keyword">lemma</span> <a name="alloc_left_unmapped_emb_896">alloc_left_unmapped_emb</a>:
    <span class="keyword">forall</span> emb, m1 : <a href="#mem__430">mem_</a> 'a, m2 lo hi b1 m1'.
      <a href="#mem_emb_820">mem_emb</a> emb m1 m2 -&gt;
      <a href="#alloc__591">alloc_</a> m1 lo hi = <a href="option.html#Some_5">Some</a>(b1, m1') -&gt;
      emb b1 = <a href="option.html#None_5">None</a> -&gt;
      <a href="#mem_emb_820">mem_emb</a> emb m1' m2

  <span class="keyword">lemma</span> <a name="alloc_left_mapped_emb_903">alloc_left_mapped_emb</a>:
    <span class="keyword">forall</span> a: 'a, emb, m1 : <a href="#mem__430">mem_</a> 'a, m2 lo hi b1 m1' b2 delta.
      <a href="#mem_emb_820">mem_emb</a> emb m1 m2 -&gt;
      <a href="#alloc__591">alloc_</a> m1 lo hi = <a href="option.html#Some_5">Some</a>(b1, m1') -&gt;
      emb b1 = <a href="option.html#Some_5">Some</a>(b2, delta) -&gt;
      <a href="#valid_block__448">valid_block_</a> m2 b2 -&gt;
      <a href="#fst_141">fst</a>(<a href="#bounds__432">bounds_</a> m2 b2) <a href="int.html#infix%20%3C=_25">&lt;=</a> lo <a href="int.html#infix%20+_19">+</a> delta -&gt; hi <a href="int.html#infix%20+_19">+</a> delta <a href="int.html#infix%20%3C=_25">&lt;=</a> <a href="#snd_145">snd</a>(<a href="#bounds__432">bounds_</a> m2 b2) -&gt;
      (<a href="#divide_26">divide</a> <a href="#max_alignment_24">max_alignment</a> delta) -&gt;
      (<span class="keyword">forall</span> v. <a href="#val_emb_818">val_emb</a> emb (<a href="#vundef_7">vundef</a> a) v) -&gt;
      <a href="#mem_emb_820">mem_emb</a> emb m1' m2

  <span class="keyword">lemma</span> <a name="free_left_emb_914">free_left_emb</a>:
    <span class="keyword">forall</span> emb, m1: <a href="#mem__430">mem_</a> 'a, m2 b1 m1'.
      <a href="#mem_emb_820">mem_emb</a> emb m1 m2 -&gt;
      <a href="#free__615">free_</a> m1 b1 = <a href="option.html#Some_5">Some</a> m1' -&gt;
      <a href="#mem_emb_820">mem_emb</a> emb m1' m2

  <span class="keyword">lemma</span> <a name="free_right_emb_920">free_right_emb</a>:
    <span class="keyword">forall</span> emb, m1 : <a href="#mem__430">mem_</a> 'a, m2 b2 m2'.
      <a href="#mem_emb_820">mem_emb</a> emb m1 m2 -&gt;
      (<span class="keyword">forall</span> b1 delta.
       emb b1 = <a href="option.html#Some_5">Some</a>(b2, delta) -&gt; <span class="keyword">not</span> (<a href="#valid_block__448">valid_block_</a> m1 b1)) -&gt;
      <a href="#free__615">free_</a> m2 b2 = <a href="option.html#Some_5">Some</a> m2' -&gt;
      <a href="#mem_emb_820">mem_emb</a> emb m1 m2'

  <span class="keyword">function</span> <a name="free_list_928">free_list</a> (m: <a href="#mem__430">mem_</a> 'a) (bl: <a href="list.html#list_8">list</a> <a href="#block__428">block_</a>) : <a href="option.html#option_5">option</a> (<a href="#mem__430">mem_</a> 'a) =
    <span class="keyword">match</span> bl <span class="keyword">with</span>
    | nil -&gt; <a href="option.html#Some_5">Some</a> m
    | <a href="list.html#Cons_8">Cons</a> b bs -&gt;
        <span class="keyword">match</span> <a href="#free_list_928">free_list</a> m bs <span class="keyword">with</span>
        | <a href="option.html#None_5">None</a> -&gt; <a href="option.html#None_5">None</a>
        | <a href="option.html#Some_5">Some</a> m1 -&gt; <a href="#free__615">free_</a> m1 b
        <span class="keyword">end</span>
    <span class="keyword">end</span>

  <span class="keyword">lemma</span> <a name="free_list_left_emb_938">free_list_left_emb</a>:
    <span class="keyword">forall</span> emb, m2: <a href="#mem__430">mem_</a> 'a, l m1 m1'.
      <a href="#mem_emb_820">mem_emb</a> emb m1 m2 -&gt;
      <a href="#free_list_928">free_list</a> m1 l = <a href="option.html#Some_5">Some</a> m1' -&gt;
      <a href="#mem_emb_820">mem_emb</a> emb m1' m2

  <span class="keyword">lemma</span> <a name="free_list_not_valid_block_944">free_list_not_valid_block</a>:
    <span class="keyword">forall</span> m: <a href="#mem__430">mem_</a> 'a, bl m'.
      <a href="#free_list_928">free_list</a> m bl = <a href="option.html#Some_5">Some</a> m' -&gt;
      <span class="keyword">forall</span> b. <a href="list.html#mem_41">mem</a> b bl -&gt; <span class="keyword">not</span> (<a href="#valid_block__448">valid_block_</a> m' b)

  <span class="keyword">lemma</span> <a name="free_list_free_parallel_emb_949">free_list_free_parallel_emb</a>:
    <span class="keyword">forall</span> emb, m1: <a href="#mem__430">mem_</a> 'a, m2 bl b2 m1' m2'.
      <a href="#mem_emb_820">mem_emb</a> emb m1 m2 -&gt;
      <a href="#free_list_928">free_list</a> m1 bl = <a href="option.html#Some_5">Some</a> m1' -&gt;
      <a href="#free__615">free_</a> m2 b2 = <a href="option.html#Some_5">Some</a> m2' -&gt;
      (<span class="keyword">forall</span> b delta'. emb b = <a href="option.html#Some_5">Some</a>(b2, delta') -&gt; <a href="list.html#mem_41">mem</a> b bl) -&gt;
      <a href="#mem_emb_820">mem_emb</a> emb m1' m2'

  <span class="keyword">lemma</span> <a name="free_parallel_emb_957">free_parallel_emb</a>:
    <span class="keyword">forall</span> emb, m1 : <a href="#mem__430">mem_</a> 'a, m2 b1 b2 m1' m2'.
      <a href="#mem_emb_820">mem_emb</a> emb m1 m2 -&gt;
      <a href="#free__615">free_</a> m1 b1 = <a href="option.html#Some_5">Some</a> m1' -&gt;
      <a href="#free__615">free_</a> m2 b2 = <a href="option.html#Some_5">Some</a> m2' -&gt;
      (<span class="keyword">forall</span> b delta'. emb b = <a href="option.html#Some_5">Some</a>(b2, delta') -&gt; b = b1) -&gt;
      <a href="#mem_emb_820">mem_emb</a> emb m1' m2'

<span class="keyword">end</span></pre>

</div>
<hr>
<p>Generated by why3doc 1.4.0+git</p>
</body>
</html>
